/****************************************************************************/
/**
 *  @file TagTable.h
 *
 *  Don't edit this header file manually. This header file is generated by
 *  executing 'make generate_tag_table' automatically.
 *  See also 'generate_tag_table.cpp'.
 */
/*----------------------------------------------------------------------------
 *
 *  Copyright (c) Visualization Laboratory, Kyoto University.
 *  All rights reserved.
 *  See http://www.viz.media.kyoto-u.ac.jp/kvs/copyright/ for details.
 *
 *  $Id: TagTable.h 631 2010-10-10 02:15:35Z naohisa.sakamoto $
 */
/****************************************************************************/
#ifndef KVS__DCM__TAG_TABLE_H_INCLUDE
#define KVS__DCM__TAG_TABLE_H_INCLUDE

#include <string>
#include "VRType.h"


namespace kvs
{

namespace dcm
{

struct TagTable
{
    unsigned short group_id;
    unsigned short element_id;
    dcm::VRType    vr_type;
    std::string    name;
};

const TagTable TAG_TABLE_0008[] =
{
    { 0x0008, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0008, 0x0005, dcm::VR_CS,   "Specific Character Set"},
    { 0x0008, 0x0008, dcm::VR_CS,   "Image Type"},
    { 0x0008, 0x0012, dcm::VR_DA,   "Instance Creation Date"},
    { 0x0008, 0x0013, dcm::VR_TM,   "Instance Creation Time"},
    { 0x0008, 0x0014, dcm::VR_UI,   "Instance Creator UID"},
    { 0x0008, 0x0016, dcm::VR_UI,   "SOP Class UID"},
    { 0x0008, 0x0018, dcm::VR_UI,   "SOP Instance UID"},
    { 0x0008, 0x0020, dcm::VR_DA,   "Study Date"},
    { 0x0008, 0x0021, dcm::VR_DA,   "Series Date"},
    { 0x0008, 0x0022, dcm::VR_DA,   "Acquisition Date"},
    { 0x0008, 0x0023, dcm::VR_DA,   "Content Date"},
    { 0x0008, 0x0024, dcm::VR_DA,   "Overlay Date"},
    { 0x0008, 0x0025, dcm::VR_DA,   "Curve Date"},
    { 0x0008, 0x002A, dcm::VR_DT,   "Acquisition Datetime"},
    { 0x0008, 0x0030, dcm::VR_TM,   "Study Time"},
    { 0x0008, 0x0031, dcm::VR_TM,   "Series Time"},
    { 0x0008, 0x0032, dcm::VR_TM,   "Acquisition Time"},
    { 0x0008, 0x0033, dcm::VR_TM,   "Content Time"},
    { 0x0008, 0x0034, dcm::VR_TM,   "Overlay Time"},
    { 0x0008, 0x0035, dcm::VR_TM,   "Curve Time"},
    { 0x0008, 0x0050, dcm::VR_SH,   "Accession Number"},
    { 0x0008, 0x0052, dcm::VR_CS,   "Query/Retrieve Level"},
    { 0x0008, 0x0054, dcm::VR_AE,   "RetrieveAE Title"},
    { 0x0008, 0x0056, dcm::VR_CS,   "Instance Availability"},
    { 0x0008, 0x0058, dcm::VR_UI,   "Failed SOP Instance UID List"},
    { 0x0008, 0x0060, dcm::VR_CS,   "Modality"},
    { 0x0008, 0x0061, dcm::VR_CS,   "Modalities in Study"},
    { 0x0008, 0x0064, dcm::VR_CS,   "Conversion Type"},
    { 0x0008, 0x0068, dcm::VR_CS,   "Presentation Intent Type"},
    { 0x0008, 0x0070, dcm::VR_LO,   "Manufacturer"},
    { 0x0008, 0x0080, dcm::VR_LO,   "Institution Name"},
    { 0x0008, 0x0081, dcm::VR_ST,   "Institution Address"},
    { 0x0008, 0x0082, dcm::VR_SQ,   "Institution Code Sequence"},
    { 0x0008, 0x0090, dcm::VR_PN,   "Referring Physician's Name"},
    { 0x0008, 0x0092, dcm::VR_ST,   "Referring Physician's Address"},
    { 0x0008, 0x0094, dcm::VR_SH,   "Referring Physician's Telephone Numbers"},
    { 0x0008, 0x0096, dcm::VR_SQ,   "Referring Physician Identification Sequence"},
    { 0x0008, 0x0100, dcm::VR_SH,   "Code Value"},
    { 0x0008, 0x0102, dcm::VR_SH,   "Coding Scheme Designator"},
    { 0x0008, 0x0103, dcm::VR_SH,   "Coding Scheme Version"},
    { 0x0008, 0x0104, dcm::VR_LO,   "Code Meaning"},
    { 0x0008, 0x0105, dcm::VR_CS,   "Mapping Resource"},
    { 0x0008, 0x0106, dcm::VR_DT,   "Context Group Version"},
    { 0x0008, 0x0107, dcm::VR_DT,   "Context Group Local Version"},
    { 0x0008, 0x010B, dcm::VR_CS,   "Context Group Extension Flag"},
    { 0x0008, 0x010C, dcm::VR_UI,   "Coding Scheme UID"},
    { 0x0008, 0x010D, dcm::VR_UI,   "Context Group Extension Creator UID"},
    { 0x0008, 0x010F, dcm::VR_CS,   "Context Identifier"},
    { 0x0008, 0x0110, dcm::VR_SQ,   "Coding Scheme Identification Sequence"},
    { 0x0008, 0x0112, dcm::VR_LO,   "Coding Scheme Registry"},
    { 0x0008, 0x0114, dcm::VR_ST,   "Coding Scheme External ID"},
    { 0x0008, 0x0115, dcm::VR_ST,   "Coding Scheme Name"},
    { 0x0008, 0x0116, dcm::VR_ST,   "Responsible Organization"},
    { 0x0008, 0x0201, dcm::VR_SH,   "Timezone Offset From UTC"},
    { 0x0008, 0x1010, dcm::VR_SH,   "Station Name"},
    { 0x0008, 0x1030, dcm::VR_LO,   "Study Description"},
    { 0x0008, 0x1032, dcm::VR_SQ,   "Procedure Code Sequence"},
    { 0x0008, 0x103E, dcm::VR_LO,   "Series Description"},
    { 0x0008, 0x1040, dcm::VR_LO,   "Institutional Department Name"},
    { 0x0008, 0x1048, dcm::VR_PN,   "Physician(s) of Record"},
    { 0x0008, 0x1049, dcm::VR_SQ,   "Physician(s) of Record Identification Sequence"},
    { 0x0008, 0x1050, dcm::VR_PN,   "Performing Physician's Name"},
    { 0x0008, 0x1052, dcm::VR_SQ,   "Performing Physician Identification Sequence"},
    { 0x0008, 0x1060, dcm::VR_PN,   "Name of Physician(s) Reading Study"},
    { 0x0008, 0x1062, dcm::VR_SQ,   "Physician(s) Reading Study Identification Sequence"},
    { 0x0008, 0x1070, dcm::VR_PN,   "Operators' Name"},
    { 0x0008, 0x1072, dcm::VR_SQ,   "Operator Identification Sequence"},
    { 0x0008, 0x1080, dcm::VR_LO,   "Admitting Diagnoses Description"},
    { 0x0008, 0x1084, dcm::VR_SQ,   "Admitting Diagnoses Code Sequence"},
    { 0x0008, 0x1090, dcm::VR_LO,   "Manufacturer's Model Name"},
    { 0x0008, 0x1100, dcm::VR_SQ,   "Referenced Results Sequence"},
    { 0x0008, 0x1110, dcm::VR_SQ,   "Referenced Study Sequence"},
    { 0x0008, 0x1111, dcm::VR_SQ,   "Referenced Performed Procedure Step Sequence"},
    { 0x0008, 0x1115, dcm::VR_SQ,   "Referenced Series Sequence"},
    { 0x0008, 0x1120, dcm::VR_SQ,   "Referenced Patient Sequence"},
    { 0x0008, 0x1125, dcm::VR_SQ,   "Referenced Visit Sequence"},
    { 0x0008, 0x1130, dcm::VR_SQ,   "Referenced Overlay Sequence"},
    { 0x0008, 0x113A, dcm::VR_SQ,   "Referenced Waveform Sequence"},
    { 0x0008, 0x1140, dcm::VR_SQ,   "Referenced Image Sequence"},
    { 0x0008, 0x1145, dcm::VR_SQ,   "Referenced Curve Sequence"},
    { 0x0008, 0x114A, dcm::VR_SQ,   "Referenced Instance Sequence"},
    { 0x0008, 0x1150, dcm::VR_UI,   "Referenced SOP Class UID"},
    { 0x0008, 0x1155, dcm::VR_UI,   "Referenced SOP Instance UID"},
    { 0x0008, 0x115A, dcm::VR_UI,   "SOP Classes Supported"},
    { 0x0008, 0x1160, dcm::VR_IS,   "Referenced Frame Number"},
    { 0x0008, 0x1195, dcm::VR_UI,   "Transaction UID"},
    { 0x0008, 0x1197, dcm::VR_US,   "Failure Reason"},
    { 0x0008, 0x1198, dcm::VR_SQ,   "Failed SOP Sequence"},
    { 0x0008, 0x1199, dcm::VR_SQ,   "Referenced SOP Sequence"},
    { 0x0008, 0x2111, dcm::VR_ST,   "Derivation Description"},
    { 0x0008, 0x2112, dcm::VR_SQ,   "Source Image Sequence"},
    { 0x0008, 0x2120, dcm::VR_SH,   "Stage Name"},
    { 0x0008, 0x2122, dcm::VR_IS,   "Stage Number"},
    { 0x0008, 0x2124, dcm::VR_IS,   "Number of Stages"},
    { 0x0008, 0x2127, dcm::VR_SH,   "View Name"},
    { 0x0008, 0x2128, dcm::VR_IS,   "View Number"},
    { 0x0008, 0x2129, dcm::VR_IS,   "Number of Event Timers"},
    { 0x0008, 0x212A, dcm::VR_IS,   "Number of Views in Stage"},
    { 0x0008, 0x2130, dcm::VR_DS,   "Event Elapsed Time(s)"},
    { 0x0008, 0x2132, dcm::VR_LO,   "Event Timer Name(s)"},
    { 0x0008, 0x2142, dcm::VR_IS,   "Start Trim"},
    { 0x0008, 0x2143, dcm::VR_IS,   "Stop Trim"},
    { 0x0008, 0x2144, dcm::VR_IS,   "Recommended Display Frame Rate"},
    { 0x0008, 0x2218, dcm::VR_SQ,   "Anatomic Region Sequence"},
    { 0x0008, 0x2220, dcm::VR_SQ,   "Anatomic Region Modifier Sequence"},
    { 0x0008, 0x2228, dcm::VR_SQ,   "Primary Anatomic Structure Sequence"},
    { 0x0008, 0x2229, dcm::VR_SQ,   "Anatomic Structure, Space or Region Sequence"},
    { 0x0008, 0x2230, dcm::VR_SQ,   "Primary Anatomic Structure Modifier Sequence"},
    { 0x0008, 0x2240, dcm::VR_SQ,   "Transducer Position Sequence"},
    { 0x0008, 0x2242, dcm::VR_SQ,   "Transducer Position Modifier Sequence"},
    { 0x0008, 0x2244, dcm::VR_SQ,   "Transducer Orientation Sequence"},
    { 0x0008, 0x2246, dcm::VR_SQ,   "Transducer Orientation Modifier Sequence"},
    { 0x0008, 0x9007, dcm::VR_CS,   "Frame Type"},
    { 0x0008, 0x9092, dcm::VR_SQ,   "Referenced Image Evidence Sequence"},
    { 0x0008, 0x9121, dcm::VR_SQ,   "Referenced Raw Data Sequence"},
    { 0x0008, 0x9123, dcm::VR_UI,   "Creator-Version UID"},
    { 0x0008, 0x9124, dcm::VR_SQ,   "Derivation Image Sequence"},
    { 0x0008, 0x9154, dcm::VR_SQ,   "Source Image Evidence Sequence"},
    { 0x0008, 0x9205, dcm::VR_CS,   "Pixel Presentation"},
    { 0x0008, 0x9206, dcm::VR_CS,   "Volumetric Properties"},
    { 0x0008, 0x9207, dcm::VR_CS,   "Volume Based Calculation Technique"},
    { 0x0008, 0x9208, dcm::VR_CS,   "Complex Image Component"},
    { 0x0008, 0x9209, dcm::VR_CS,   "Acquisition Contrast"},
    { 0x0008, 0x9215, dcm::VR_SQ,   "Derivation Code Sequence"},
    { 0x0008, 0x9237, dcm::VR_SQ,   "Referenced Grayscale Presentation State Sequence"},
};

const int TAG_TABLE_0008_SIZE = sizeof( TAG_TABLE_0008 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0010[] =
{
    { 0x0010, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0010, 0x0010, dcm::VR_PN,   "Patient's Name"},
    { 0x0010, 0x0020, dcm::VR_LO,   "Patient ID"},
    { 0x0010, 0x0021, dcm::VR_LO,   "Issuer of Patient ID"},
    { 0x0010, 0x0030, dcm::VR_DA,   "Patient's Birth Date"},
    { 0x0010, 0x0032, dcm::VR_TM,   "Patient's Birth Time"},
    { 0x0010, 0x0040, dcm::VR_CS,   "Patient's Sex"},
    { 0x0010, 0x0050, dcm::VR_SQ,   "Patient's Insurance Plan Code Sequence"},
    { 0x0010, 0x0101, dcm::VR_SQ,   "Patient's Primary Language Code Sequence"},
    { 0x0010, 0x0102, dcm::VR_SQ,   "Patient's Primary Language Code Modifier Sequence"},
    { 0x0010, 0x1000, dcm::VR_LO,   "Other Patient IDs"},
    { 0x0010, 0x1001, dcm::VR_PN,   "Other Patient Names"},
    { 0x0010, 0x1005, dcm::VR_PN,   "Patient's Birth Name"},
    { 0x0010, 0x1010, dcm::VR_AS,   "Patient's Age"},
    { 0x0010, 0x1020, dcm::VR_DS,   "Patient's Size"},
    { 0x0010, 0x1030, dcm::VR_DS,   "Patient's Weight"},
    { 0x0010, 0x1040, dcm::VR_LO,   "Patient's Address"},
    { 0x0010, 0x1060, dcm::VR_PN,   "Patient's Mother's Birth Name"},
    { 0x0010, 0x1080, dcm::VR_LO,   "Military Rank"},
    { 0x0010, 0x1081, dcm::VR_LO,   "Branch of Service"},
    { 0x0010, 0x1090, dcm::VR_LO,   "Medical Record Locator"},
    { 0x0010, 0x2000, dcm::VR_LO,   "Medical Alerts"},
    { 0x0010, 0x2110, dcm::VR_LO,   "Contrast Allergies"},
    { 0x0010, 0x2150, dcm::VR_LO,   "Country of Residence"},
    { 0x0010, 0x2152, dcm::VR_LO,   "Region of Residence"},
    { 0x0010, 0x2154, dcm::VR_SH,   "Patient's Telephone Numbers"},
    { 0x0010, 0x2160, dcm::VR_SH,   "Ethnic Group"},
    { 0x0010, 0x2180, dcm::VR_SH,   "Occupation"},
    { 0x0010, 0x21A0, dcm::VR_CS,   "Smoking Status"},
    { 0x0010, 0x21B0, dcm::VR_LT,   "Additional Patient History"},
    { 0x0010, 0x21C0, dcm::VR_US,   "Pregnancy Status"},
    { 0x0010, 0x21D0, dcm::VR_DA,   "Last Menstrual Date"},
    { 0x0010, 0x21F0, dcm::VR_LO,   "Patient's Religious Preference"},
    { 0x0010, 0x4000, dcm::VR_LT,   "Patient Comments"},
};

const int TAG_TABLE_0010_SIZE = sizeof( TAG_TABLE_0010 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0018[] =
{
    { 0x0018, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0018, 0x0010, dcm::VR_LO,   "Contrast/Bolus Agent"},
    { 0x0018, 0x0012, dcm::VR_SQ,   "Contrast/Bolus Agent Sequence"},
    { 0x0018, 0x0014, dcm::VR_SQ,   "Contrast/Bolus Administration Route Sequence"},
    { 0x0018, 0x0015, dcm::VR_CS,   "Body Part Examined"},
    { 0x0018, 0x0020, dcm::VR_CS,   "Scanning Sequence"},
    { 0x0018, 0x0021, dcm::VR_CS,   "Sequence Variant"},
    { 0x0018, 0x0022, dcm::VR_CS,   "Scan Options"},
    { 0x0018, 0x0023, dcm::VR_CS,   "MR Acquisition Type"},
    { 0x0018, 0x0024, dcm::VR_SH,   "Sequence Name"},
    { 0x0018, 0x0025, dcm::VR_CS,   "Angio Flag"},
    { 0x0018, 0x0026, dcm::VR_SQ,   "Intervention Drug Information Sequence"},
    { 0x0018, 0x0027, dcm::VR_TM,   "Intervention Drug Stop Time"},
    { 0x0018, 0x0028, dcm::VR_DS,   "Intervention Drug Dose"},
    { 0x0018, 0x0029, dcm::VR_SQ,   "Intervention Drug Code Sequence"},
    { 0x0018, 0x002A, dcm::VR_SQ,   "Additional Drug Sequence"},
    { 0x0018, 0x0031, dcm::VR_LO,   "Radiopharmaceutical"},
    { 0x0018, 0x0034, dcm::VR_LO,   "Intervention Drug Name"},
    { 0x0018, 0x0035, dcm::VR_TM,   "Intervention Drug Start Time"},
    { 0x0018, 0x0036, dcm::VR_SQ,   "Interventional Therapy Sequence"},
    { 0x0018, 0x0038, dcm::VR_CS,   "Interventional Status"},
    { 0x0018, 0x0039, dcm::VR_CS,   "Therapy Description"},
    { 0x0018, 0x0040, dcm::VR_IS,   "Cine Rate"},
    { 0x0018, 0x0050, dcm::VR_DS,   "Slice Thickness"},
    { 0x0018, 0x0060, dcm::VR_DS,   "KVP"},
    { 0x0018, 0x0070, dcm::VR_IS,   "Counts Accumulated"},
    { 0x0018, 0x0071, dcm::VR_CS,   "Acquisition Termination Condition"},
    { 0x0018, 0x0072, dcm::VR_DS,   "Effective Duration"},
    { 0x0018, 0x0073, dcm::VR_CS,   "Acquisition Start Condition"},
    { 0x0018, 0x0074, dcm::VR_IS,   "Acquisition Start Condition Data"},
    { 0x0018, 0x0075, dcm::VR_IS,   "Acquisition Termination Condition Data"},
    { 0x0018, 0x0080, dcm::VR_DS,   "Repetition Time"},
    { 0x0018, 0x0081, dcm::VR_DS,   "Echo Time"},
    { 0x0018, 0x0082, dcm::VR_DS,   "Inversion Time"},
    { 0x0018, 0x0083, dcm::VR_DS,   "Number of Averages"},
    { 0x0018, 0x0084, dcm::VR_DS,   "Imaging Frequency"},
    { 0x0018, 0x0085, dcm::VR_SH,   "Imaged Nucleus"},
    { 0x0018, 0x0086, dcm::VR_IS,   "Echo Number(s)"},
    { 0x0018, 0x0087, dcm::VR_DS,   "Magnetic Field Strength"},
    { 0x0018, 0x0088, dcm::VR_DS,   "Spacing Between Slices"},
    { 0x0018, 0x0089, dcm::VR_IS,   "Number of Phase Encoding Steps"},
    { 0x0018, 0x0090, dcm::VR_DS,   "Data Collection Diameter"},
    { 0x0018, 0x0091, dcm::VR_IS,   "Echo Train Length"},
    { 0x0018, 0x0093, dcm::VR_DS,   "Percent Sampling"},
    { 0x0018, 0x0094, dcm::VR_DS,   "Percent Phase Field of View"},
    { 0x0018, 0x0095, dcm::VR_DS,   "Pixel Bandwidth"},
    { 0x0018, 0x1000, dcm::VR_LO,   "Device Serial Number"},
    { 0x0018, 0x1004, dcm::VR_LO,   "Plate ID"},
    { 0x0018, 0x1010, dcm::VR_LO,   "Secondary Capture Device ID"},
    { 0x0018, 0x1011, dcm::VR_LO,   "Hardcopy Creation Device ID"},
    { 0x0018, 0x1012, dcm::VR_DA,   "Date of Secondary Capture"},
    { 0x0018, 0x1014, dcm::VR_TM,   "Time of Secondary Capture"},
    { 0x0018, 0x1016, dcm::VR_LO,   "Secondary Capture Device Manufacturer"},
    { 0x0018, 0x1017, dcm::VR_LO,   "Hardcopy Device Manufacturer"},
    { 0x0018, 0x1018, dcm::VR_LO,   "Secondary Capture Device Manufacturer's Model Name"},
    { 0x0018, 0x1019, dcm::VR_LO,   "Secondary Capture Device Software Version(s)"},
    { 0x0018, 0x101A, dcm::VR_LO,   "Hardcopy Device Software Version"},
    { 0x0018, 0x101B, dcm::VR_LO,   "Hardcopy Device Manfuacturer's Model Name"},
    { 0x0018, 0x1020, dcm::VR_LO,   "Software Version(s)"},
    { 0x0018, 0x1022, dcm::VR_SH,   "Video Image Format Acquired"},
    { 0x0018, 0x1023, dcm::VR_LO,   "Digital Image Format Acquired"},
    { 0x0018, 0x1030, dcm::VR_LO,   "Protocol Name"},
    { 0x0018, 0x1040, dcm::VR_LO,   "Contrast/Bolus Route"},
    { 0x0018, 0x1041, dcm::VR_DS,   "Contrast/Bolus Volume"},
    { 0x0018, 0x1042, dcm::VR_TM,   "Contrast/Bolus Start Time"},
    { 0x0018, 0x1043, dcm::VR_TM,   "Contrast/Bolus Stop Time"},
    { 0x0018, 0x1044, dcm::VR_DS,   "Contrast/Bolus Total Dose"},
    { 0x0018, 0x1045, dcm::VR_IS,   "Syringe Counts"},
    { 0x0018, 0x1046, dcm::VR_DS,   "Contrast Flow Rate(s)"},
    { 0x0018, 0x1047, dcm::VR_DS,   "Contrast Flow Duration(s)"},
    { 0x0018, 0x1048, dcm::VR_CS,   "Contrast/Bolus Ingredient"},
    { 0x0018, 0x1049, dcm::VR_DS,   "Contrast/Bolus Ingredient Concentration"},
    { 0x0018, 0x1050, dcm::VR_DS,   "Spatial Resolution"},
    { 0x0018, 0x1060, dcm::VR_DS,   "Trigger Time"},
    { 0x0018, 0x1061, dcm::VR_LO,   "Trigger Source or Type"},
    { 0x0018, 0x1062, dcm::VR_IS,   "Nominal Interval"},
    { 0x0018, 0x1063, dcm::VR_DS,   "Frame Time"},
    { 0x0018, 0x1064, dcm::VR_LO,   "Framing Type"},
    { 0x0018, 0x1065, dcm::VR_DS,   "Frame Time Vector"},
    { 0x0018, 0x1066, dcm::VR_DS,   "Frame Delay"},
    { 0x0018, 0x1067, dcm::VR_DS,   "Image Trigger Delay"},
    { 0x0018, 0x1068, dcm::VR_DS,   "Multiplex Group Time Offset"},
    { 0x0018, 0x1069, dcm::VR_DS,   "Trigger Time Offset"},
    { 0x0018, 0x106A, dcm::VR_CS,   "Synchronization Trigger"},
    { 0x0018, 0x106C, dcm::VR_US,   "Synchronization Channel"},
    { 0x0018, 0x106E, dcm::VR_UL,   "Trigger Sample Position"},
    { 0x0018, 0x1070, dcm::VR_LO,   "Radiopharmaceutical Route"},
    { 0x0018, 0x1071, dcm::VR_DS,   "Radiopharmaceutical Volume"},
    { 0x0018, 0x1072, dcm::VR_TM,   "Radiopharmaceutical Start Time"},
    { 0x0018, 0x1073, dcm::VR_TM,   "Radiopharmaceutical Stop Time"},
    { 0x0018, 0x1074, dcm::VR_DS,   "Radionuclide Total Dose"},
    { 0x0018, 0x1075, dcm::VR_DS,   "Radionuclide Half Life"},
    { 0x0018, 0x1076, dcm::VR_DS,   "Radionuclide Positron Fraction"},
    { 0x0018, 0x1077, dcm::VR_DS,   "Radiopharmaceutical Specific Activity"},
    { 0x0018, 0x1080, dcm::VR_CS,   "Beat Rejection Flag"},
    { 0x0018, 0x1081, dcm::VR_IS,   "Low R-R Value"},
    { 0x0018, 0x1082, dcm::VR_IS,   "High R-R Value"},
    { 0x0018, 0x1083, dcm::VR_IS,   "Intervals Acquired"},
    { 0x0018, 0x1084, dcm::VR_IS,   "Intervals Rejected"},
    { 0x0018, 0x1085, dcm::VR_LO,   "PVC Rejection"},
    { 0x0018, 0x1086, dcm::VR_IS,   "Skip Beats"},
    { 0x0018, 0x1088, dcm::VR_IS,   "Heart Rate"},
    { 0x0018, 0x1090, dcm::VR_IS,   "Cardiac Number of Images"},
    { 0x0018, 0x1094, dcm::VR_IS,   "Trigger Window"},
    { 0x0018, 0x1100, dcm::VR_DS,   "Reconstruction Diameter"},
    { 0x0018, 0x1110, dcm::VR_DS,   "Distance Source to Detector"},
    { 0x0018, 0x1111, dcm::VR_DS,   "Distance Source to Patient"},
    { 0x0018, 0x1114, dcm::VR_DS,   "Estimated Radiographic Magnification Factor"},
    { 0x0018, 0x1120, dcm::VR_DS,   "Gantry/Detector Tilt"},
    { 0x0018, 0x1121, dcm::VR_DS,   "Gantry/Detector Slew"},
    { 0x0018, 0x1130, dcm::VR_DS,   "Table Height"},
    { 0x0018, 0x1131, dcm::VR_DS,   "Table Traverse"},
    { 0x0018, 0x1134, dcm::VR_CS,   "Table Motion"},
    { 0x0018, 0x1135, dcm::VR_DS,   "Table Vertical Increment"},
    { 0x0018, 0x1136, dcm::VR_DS,   "Table Lateral Increment"},
    { 0x0018, 0x1137, dcm::VR_DS,   "Table Longitudinal Increment"},
    { 0x0018, 0x1138, dcm::VR_DS,   "Table Angle"},
    { 0x0018, 0x113A, dcm::VR_CS,   "Table Type"},
    { 0x0018, 0x1140, dcm::VR_CS,   "Rotation Direction"},
    { 0x0018, 0x1141, dcm::VR_DS,   "Angular Position"},
    { 0x0018, 0x1142, dcm::VR_DS,   "Radial Position"},
    { 0x0018, 0x1143, dcm::VR_DS,   "Scan Arc"},
    { 0x0018, 0x1144, dcm::VR_DS,   "Angular Step"},
    { 0x0018, 0x1145, dcm::VR_DS,   "Center of Rotation Offset"},
    { 0x0018, 0x1147, dcm::VR_CS,   "Field of View Shape"},
    { 0x0018, 0x1149, dcm::VR_IS,   "Field of View Dimension(s)"},
    { 0x0018, 0x1150, dcm::VR_IS,   "Exposure Time"},
    { 0x0018, 0x1151, dcm::VR_IS,   "X-ray Tube Current"},
    { 0x0018, 0x1152, dcm::VR_IS,   "Exposure"},
    { 0x0018, 0x1153, dcm::VR_IS,   "Exposure in uAs"},
    { 0x0018, 0x1154, dcm::VR_DS,   "Average Pulse Width"},
    { 0x0018, 0x1155, dcm::VR_CS,   "Radiation Setting"},
    { 0x0018, 0x1156, dcm::VR_CS,   "Rectification Type"},
    { 0x0018, 0x115A, dcm::VR_CS,   "Radiation Mode"},
    { 0x0018, 0x115E, dcm::VR_DS,   "Image Area Dose Product"},
    { 0x0018, 0x1160, dcm::VR_SH,   "Filter Type"},
    { 0x0018, 0x1161, dcm::VR_LO,   "Type of Filters"},
    { 0x0018, 0x1162, dcm::VR_DS,   "Intensifier Size"},
    { 0x0018, 0x1164, dcm::VR_DS,   "Imager Pixel Spacing"},
    { 0x0018, 0x1166, dcm::VR_CS,   "Grid"},
    { 0x0018, 0x1170, dcm::VR_IS,   "Generator Power"},
    { 0x0018, 0x1180, dcm::VR_SH,   "Collimator/grid Name"},
    { 0x0018, 0x1181, dcm::VR_CS,   "Collimator Type"},
    { 0x0018, 0x1182, dcm::VR_IS,   "Focal Distance"},
    { 0x0018, 0x1183, dcm::VR_DS,   "X Focus Center"},
    { 0x0018, 0x1184, dcm::VR_DS,   "Y Focus Center"},
    { 0x0018, 0x1190, dcm::VR_DS,   "Focal Spot(s)"},
    { 0x0018, 0x1191, dcm::VR_CS,   "Anode Target Material"},
    { 0x0018, 0x11A0, dcm::VR_DS,   "Body Part Thickness"},
    { 0x0018, 0x11A2, dcm::VR_DS,   "Compression Force"},
    { 0x0018, 0x1200, dcm::VR_DA,   "Date of Last Calibration"},
    { 0x0018, 0x1201, dcm::VR_TM,   "Time of Last Calibration"},
    { 0x0018, 0x1210, dcm::VR_SH,   "Convolution Kernel"},
    { 0x0018, 0x1240, dcm::VR_IS,   "Upper/Lower Pixel Values"},
    { 0x0018, 0x1242, dcm::VR_IS,   "Actual Frame Duration"},
    { 0x0018, 0x1243, dcm::VR_IS,   "Count Rate"},
    { 0x0018, 0x1244, dcm::VR_US,   "Preferred Playback Sequencing"},
    { 0x0018, 0x1250, dcm::VR_SH,   "Receive Coil Name"},
    { 0x0018, 0x1251, dcm::VR_SH,   "Transmit Coil Name"},
    { 0x0018, 0x1260, dcm::VR_SH,   "Plate Type"},
    { 0x0018, 0x1261, dcm::VR_LO,   "Phosphor Type"},
    { 0x0018, 0x1300, dcm::VR_DS,   "Scan Velocity"},
    { 0x0018, 0x1301, dcm::VR_CS,   "Whole Body Technique"},
    { 0x0018, 0x1302, dcm::VR_IS,   "Scan Length"},
    { 0x0018, 0x1310, dcm::VR_US,   "Acquisition Matrix"},
    { 0x0018, 0x1312, dcm::VR_CS,   "In-plane Phase Encoding Direction"},
    { 0x0018, 0x1314, dcm::VR_DS,   "Flip Angle"},
    { 0x0018, 0x1315, dcm::VR_CS,   "Variable Flip Angle Flag"},
    { 0x0018, 0x1316, dcm::VR_DS,   "SAR"},
    { 0x0018, 0x1318, dcm::VR_DS,   "dB/dt"},
    { 0x0018, 0x1400, dcm::VR_LO,   "Acquisition Device Processing Description"},
    { 0x0018, 0x1401, dcm::VR_LO,   "Acquisition Device Processing Code"},
    { 0x0018, 0x1402, dcm::VR_CS,   "Cassette Orientation"},
    { 0x0018, 0x1403, dcm::VR_CS,   "Cassette Size"},
    { 0x0018, 0x1404, dcm::VR_US,   "Exposures on Plate"},
    { 0x0018, 0x1405, dcm::VR_IS,   "Relative X-ray Exposure"},
    { 0x0018, 0x1450, dcm::VR_DS,   "Column Angulation"},
    { 0x0018, 0x1460, dcm::VR_DS,   "Tomo Layer Height"},
    { 0x0018, 0x1470, dcm::VR_DS,   "Tomo Angle"},
    { 0x0018, 0x1480, dcm::VR_DS,   "Tomo Time"},
    { 0x0018, 0x1490, dcm::VR_CS,   "Tomo Type"},
    { 0x0018, 0x1491, dcm::VR_CS,   "Tomo Class"},
    { 0x0018, 0x1495, dcm::VR_IS,   "Number of Tomosynthesis Source Images"},
    { 0x0018, 0x1500, dcm::VR_CS,   "Positioner Motion"},
    { 0x0018, 0x1508, dcm::VR_CS,   "Positioner Type"},
    { 0x0018, 0x1510, dcm::VR_DS,   "Positioner Primary Angle"},
    { 0x0018, 0x1511, dcm::VR_DS,   "Positioner Secondary Angle"},
    { 0x0018, 0x1520, dcm::VR_DS,   "Positioner Primary Angle Increment"},
    { 0x0018, 0x1521, dcm::VR_DS,   "Positioner Secondary Angle Increment"},
    { 0x0018, 0x1530, dcm::VR_DS,   "Detector Primary Angle"},
    { 0x0018, 0x1531, dcm::VR_DS,   "Detector Secondary Angle"},
    { 0x0018, 0x1600, dcm::VR_CS,   "Shutter Shape"},
    { 0x0018, 0x1602, dcm::VR_IS,   "Shutter Left Vertical Edge"},
    { 0x0018, 0x1604, dcm::VR_IS,   "Shutter Right Vertical Edge"},
    { 0x0018, 0x1606, dcm::VR_IS,   "Shutter Upper Horizontal Edge"},
    { 0x0018, 0x1608, dcm::VR_IS,   "Shutter Lower Horizontal Edge"},
    { 0x0018, 0x1610, dcm::VR_IS,   "Center of Circular Shutter"},
    { 0x0018, 0x1612, dcm::VR_IS,   "Radius of Circular Shutter"},
    { 0x0018, 0x1620, dcm::VR_IS,   "Vertices of the Polygonal Shutter"},
    { 0x0018, 0x1622, dcm::VR_US,   "Shutter Presentation Value"},
    { 0x0018, 0x1623, dcm::VR_US,   "Shutter Overlay Group"},
    { 0x0018, 0x1700, dcm::VR_CS,   "Collimator Shape"},
    { 0x0018, 0x1702, dcm::VR_IS,   "Collimator Left Vertical Edge"},
    { 0x0018, 0x1704, dcm::VR_IS,   "Collimator Right Vertical Edge"},
    { 0x0018, 0x1706, dcm::VR_IS,   "Collimator Upper Horizontal Edge"},
    { 0x0018, 0x1708, dcm::VR_IS,   "Collimator Lower Horizontal Edge"},
    { 0x0018, 0x1710, dcm::VR_IS,   "Center of Circular Collimator"},
    { 0x0018, 0x1712, dcm::VR_IS,   "Radius of Circular Collimator"},
    { 0x0018, 0x1720, dcm::VR_IS,   "Vertices of the Polygonal Collimator"},
    { 0x0018, 0x1800, dcm::VR_CS,   "Acquisition Time Synchronized"},
    { 0x0018, 0x1801, dcm::VR_SH,   "Time Source"},
    { 0x0018, 0x1802, dcm::VR_CS,   "Time Distribution Protocol"},
    { 0x0018, 0x2001, dcm::VR_IS,   "Page Number Vector"},
    { 0x0018, 0x2002, dcm::VR_SH,   "Frame Label Vector"},
    { 0x0018, 0x2003, dcm::VR_DS,   "Frame Primary Angle Vector"},
    { 0x0018, 0x2004, dcm::VR_DS,   "Frame Secondary Angle Vector"},
    { 0x0018, 0x2005, dcm::VR_DS,   "Slice Location Vector"},
    { 0x0018, 0x2006, dcm::VR_SH,   "Display Window Label Vector"},
    { 0x0018, 0x2010, dcm::VR_DS,   "Nominal Scanned Pixel Spacing"},
    { 0x0018, 0x2020, dcm::VR_CS,   "Digitizing Device Transport Direction"},
    { 0x0018, 0x2030, dcm::VR_DS,   "Rotation of Scanned Film"},
    { 0x0018, 0x3100, dcm::VR_CS,   "IVUS Acquisition"},
    { 0x0018, 0x3101, dcm::VR_DS,   "IVUS Pullback Rate"},
    { 0x0018, 0x3102, dcm::VR_DS,   "IVUS Gated Rate"},
    { 0x0018, 0x3103, dcm::VR_IS,   "IVUS Pullback Start Frame Number"},
    { 0x0018, 0x3104, dcm::VR_IS,   "IVUS Pullback Stop Frame Number"},
    { 0x0018, 0x3105, dcm::VR_IS,   "Lesion Number"},
    { 0x0018, 0x5000, dcm::VR_SH,   "Output Power"},
    { 0x0018, 0x5010, dcm::VR_LO,   "Transducer Data"},
    { 0x0018, 0x5012, dcm::VR_DS,   "Focus Depth"},
    { 0x0018, 0x5020, dcm::VR_LO,   "Processing Function"},
    { 0x0018, 0x5021, dcm::VR_LO,   "Postprocessing Function"},
    { 0x0018, 0x5022, dcm::VR_DS,   "Mechanical Index"},
    { 0x0018, 0x5024, dcm::VR_DS,   "Bone Thermal Index"},
    { 0x0018, 0x5026, dcm::VR_DS,   "Cranial Thermal Index"},
    { 0x0018, 0x5027, dcm::VR_DS,   "Soft Tissue Thermal Index"},
    { 0x0018, 0x5028, dcm::VR_DS,   "Soft Tissue-focus Thermal Index"},
    { 0x0018, 0x5029, dcm::VR_DS,   "Soft Tissue-surface Thermal Index"},
    { 0x0018, 0x5050, dcm::VR_IS,   "Depth of Scan Field"},
    { 0x0018, 0x5100, dcm::VR_CS,   "Patient Position"},
    { 0x0018, 0x5101, dcm::VR_CS,   "View Position"},
    { 0x0018, 0x5104, dcm::VR_SQ,   "Projection Eponymous Name Code Sequence"},
    { 0x0018, 0x5210, dcm::VR_DS,   "Image Transformation Matrix"},
    { 0x0018, 0x5212, dcm::VR_DS,   "Image Translation Vector"},
    { 0x0018, 0x6000, dcm::VR_DS,   "Sensitivity"},
    { 0x0018, 0x6011, dcm::VR_SQ,   "Sequence of Ultrasound Regions"},
    { 0x0018, 0x6012, dcm::VR_US,   "Region Spatial Format"},
    { 0x0018, 0x6014, dcm::VR_US,   "Region Data Type"},
    { 0x0018, 0x6016, dcm::VR_UL,   "Region Flags"},
    { 0x0018, 0x6018, dcm::VR_UL,   "Region Location Min X0"},
    { 0x0018, 0x601A, dcm::VR_UL,   "Region Location Min Y0"},
    { 0x0018, 0x601C, dcm::VR_UL,   "Region Location Max X1"},
    { 0x0018, 0x601E, dcm::VR_UL,   "Region Location Max Y1"},
    { 0x0018, 0x6020, dcm::VR_SL,   "Reference Pixel X0"},
    { 0x0018, 0x6022, dcm::VR_SL,   "Reference Pixel Y0"},
    { 0x0018, 0x6024, dcm::VR_US,   "Physical Units X Direction"},
    { 0x0018, 0x6026, dcm::VR_US,   "Physical Units Y Direction"},
    { 0x0018, 0x6028, dcm::VR_FD,   "Reference Pixel Physical Value X"},
    { 0x0018, 0x602A, dcm::VR_FD,   "Reference Pixel Physical Value Y"},
    { 0x0018, 0x602C, dcm::VR_FD,   "Physical Delta X"},
    { 0x0018, 0x602E, dcm::VR_FD,   "Physical Delta Y"},
    { 0x0018, 0x6030, dcm::VR_UL,   "Transducer Frequency"},
    { 0x0018, 0x6031, dcm::VR_CS,   "Transducer Type"},
    { 0x0018, 0x6032, dcm::VR_UL,   "Pulse Repetition Frequency"},
    { 0x0018, 0x6034, dcm::VR_FD,   "Doppler Correction Angle"},
    { 0x0018, 0x6036, dcm::VR_FD,   "Steering Angle"},
    { 0x0018, 0x6039, dcm::VR_SL,   "Doppler Sample Volume X Position"},
    { 0x0018, 0x603B, dcm::VR_SL,   "Doppler Sample Volume Y Position"},
    { 0x0018, 0x603D, dcm::VR_SL,   "TM-Line Position X0"},
    { 0x0018, 0x603F, dcm::VR_SL,   "TM-Line Position Y0"},
    { 0x0018, 0x6041, dcm::VR_SL,   "TM-Line Position X1"},
    { 0x0018, 0x6043, dcm::VR_SL,   "TM-Line Position Y1"},
    { 0x0018, 0x6044, dcm::VR_US,   "Pixel Component Organization"},
    { 0x0018, 0x6046, dcm::VR_UL,   "Pixel Component Mask"},
    { 0x0018, 0x6048, dcm::VR_UL,   "Pixel Component Range Start"},
    { 0x0018, 0x604A, dcm::VR_UL,   "Pixel Component Range Stop"},
    { 0x0018, 0x604C, dcm::VR_US,   "Pixel Component Physical Units"},
    { 0x0018, 0x604E, dcm::VR_US,   "Pixel Component Data Type"},
    { 0x0018, 0x6050, dcm::VR_UL,   "Number of Table Break Points"},
    { 0x0018, 0x6052, dcm::VR_UL,   "Table of X Break Points"},
    { 0x0018, 0x6054, dcm::VR_FD,   "Table of Y Break Points"},
    { 0x0018, 0x6056, dcm::VR_UL,   "Number of Table Entries"},
    { 0x0018, 0x6058, dcm::VR_UL,   "Table of Pixel Values"},
    { 0x0018, 0x605A, dcm::VR_FL,   "Table of Parameter Values"},
    { 0x0018, 0x7000, dcm::VR_CS,   "Detector Conditions Nominal Flag"},
    { 0x0018, 0x7001, dcm::VR_DS,   "Detector Temperature"},
    { 0x0018, 0x7004, dcm::VR_CS,   "Detector Type"},
    { 0x0018, 0x7005, dcm::VR_CS,   "Detector Configuration"},
    { 0x0018, 0x7006, dcm::VR_LT,   "Detector Description"},
    { 0x0018, 0x7008, dcm::VR_LT,   "Detector Mode"},
    { 0x0018, 0x700A, dcm::VR_SH,   "Detector ID"},
    { 0x0018, 0x700C, dcm::VR_DA,   "Date of Last Detector Calibration"},
    { 0x0018, 0x700E, dcm::VR_TM,   "Time of Last Detector Calibration"},
    { 0x0018, 0x7010, dcm::VR_IS,   "Exposures on Detector Since Last Calibration"},
    { 0x0018, 0x7011, dcm::VR_IS,   "Exposures on Detector Since Manufactured"},
    { 0x0018, 0x7012, dcm::VR_DS,   "Detector Time Since Last Exposure"},
    { 0x0018, 0x7014, dcm::VR_DS,   "Detector Active Time"},
    { 0x0018, 0x7016, dcm::VR_DS,   "Detector Activation Offset From Exposure"},
    { 0x0018, 0x701A, dcm::VR_DS,   "Detector Binning"},
    { 0x0018, 0x7020, dcm::VR_DS,   "Detector Element Physical Size"},
    { 0x0018, 0x7022, dcm::VR_DS,   "Detector Element Spacing"},
    { 0x0018, 0x7024, dcm::VR_CS,   "Detector Active Shape"},
    { 0x0018, 0x7026, dcm::VR_DS,   "Detector Active Dimension(s)"},
    { 0x0018, 0x7028, dcm::VR_DS,   "Detector Active Origin"},
    { 0x0018, 0x7030, dcm::VR_DS,   "Field of View Origin"},
    { 0x0018, 0x7032, dcm::VR_DS,   "Field of View Rotation"},
    { 0x0018, 0x7034, dcm::VR_CS,   "Field of View Horizontal Flip"},
    { 0x0018, 0x7040, dcm::VR_LT,   "Grid Absorbing Material"},
    { 0x0018, 0x7041, dcm::VR_LT,   "Grid Spacing Material"},
    { 0x0018, 0x7042, dcm::VR_DS,   "Grid Thickness"},
    { 0x0018, 0x7044, dcm::VR_DS,   "Grid Pitch"},
    { 0x0018, 0x7046, dcm::VR_IS,   "Grid Aspect Ratio"},
    { 0x0018, 0x7048, dcm::VR_DS,   "Grid Period"},
    { 0x0018, 0x704C, dcm::VR_DS,   "Grid Focal Distance"},
    { 0x0018, 0x7050, dcm::VR_CS,   "Filter Material"},
    { 0x0018, 0x7052, dcm::VR_DS,   "Filter Thickness Minimum"},
    { 0x0018, 0x7054, dcm::VR_DS,   "Filter Thickness Maximum"},
    { 0x0018, 0x7060, dcm::VR_CS,   "Exposure Control Mode"},
    { 0x0018, 0x7062, dcm::VR_LT,   "Exposure Control Mode Description"},
    { 0x0018, 0x7064, dcm::VR_CS,   "Exposure Status"},
    { 0x0018, 0x7065, dcm::VR_DS,   "Phototimer Setting"},
    { 0x0018, 0x8150, dcm::VR_DS,   "Exposure Time in uS"},
    { 0x0018, 0x8151, dcm::VR_DS,   "X-Ray Tube Current in uA"},
    { 0x0018, 0x9004, dcm::VR_CS,   "Content Qualification"},
    { 0x0018, 0x9005, dcm::VR_SH,   "Pulse Sequence Name"},
    { 0x0018, 0x9006, dcm::VR_SQ,   "MR Imaging Modifier Sequence"},
    { 0x0018, 0x9008, dcm::VR_CS,   "Echo Pulse Sequence"},
    { 0x0018, 0x9009, dcm::VR_CS,   "Inversion Recovery"},
    { 0x0018, 0x9010, dcm::VR_CS,   "Flow Compensation"},
    { 0x0018, 0x9011, dcm::VR_CS,   "Multiple Spin Echo"},
    { 0x0018, 0x9012, dcm::VR_CS,   "Multi-planar Excitation"},
    { 0x0018, 0x9014, dcm::VR_CS,   "Phase Contrast"},
    { 0x0018, 0x9015, dcm::VR_CS,   "Time of Flight Contrast"},
    { 0x0018, 0x9016, dcm::VR_CS,   "Spoiling"},
    { 0x0018, 0x9017, dcm::VR_CS,   "Steady State Pulse Sequence"},
    { 0x0018, 0x9018, dcm::VR_CS,   "Echo Planar Pulse Sequence"},
    { 0x0018, 0x9019, dcm::VR_FD,   "Tag Angle First Axis"},
    { 0x0018, 0x9020, dcm::VR_CS,   "Magnetization Transfer"},
    { 0x0018, 0x9021, dcm::VR_CS,   "T2 Preparation"},
    { 0x0018, 0x9022, dcm::VR_CS,   "Blood Signal Nulling"},
    { 0x0018, 0x9024, dcm::VR_CS,   "Saturation Recovery"},
    { 0x0018, 0x9025, dcm::VR_CS,   "Spectrally Selected Suppression"},
    { 0x0018, 0x9026, dcm::VR_CS,   "Spectrally Selected Excitation"},
    { 0x0018, 0x9027, dcm::VR_CS,   "Spatial Pre-saturation"},
    { 0x0018, 0x9028, dcm::VR_CS,   "Tagging"},
    { 0x0018, 0x9029, dcm::VR_CS,   "Oversampling Phase"},
    { 0x0018, 0x9030, dcm::VR_FD,   "Tag Spacing First Dimension"},
    { 0x0018, 0x9032, dcm::VR_CS,   "Geometry of k-Space Traversal"},
    { 0x0018, 0x9033, dcm::VR_CS,   "Segmented k-Space Traversal"},
    { 0x0018, 0x9034, dcm::VR_CS,   "Rectilinear Phase Encode Reordering"},
    { 0x0018, 0x9035, dcm::VR_FD,   "Tag Thickness"},
    { 0x0018, 0x9036, dcm::VR_CS,   "Partial Fourier Direction"},
    { 0x0018, 0x9037, dcm::VR_CS,   "Cardiac Synchronization Technique"},
    { 0x0018, 0x9041, dcm::VR_LO,   "Receive Coil Manufacturer Name"},
    { 0x0018, 0x9042, dcm::VR_SQ,   "MR Receive Coil Sequence"},
    { 0x0018, 0x9043, dcm::VR_CS,   "Receive Coil Type"},
    { 0x0018, 0x9044, dcm::VR_CS,   "Quadrature Receive Coil"},
    { 0x0018, 0x9045, dcm::VR_SQ,   "Multi-Coil Definition Sequence"},
    { 0x0018, 0x9046, dcm::VR_LO,   "Multi-Coil Configuration"},
    { 0x0018, 0x9047, dcm::VR_SH,   "Multi-Coil Element Name"},
    { 0x0018, 0x9048, dcm::VR_CS,   "Multi-Coil Element Used"},
    { 0x0018, 0x9049, dcm::VR_SQ,   "MR Transmit Coil Sequence"},
    { 0x0018, 0x9050, dcm::VR_LO,   "Transmit Coil Manufacturer Name"},
    { 0x0018, 0x9051, dcm::VR_CS,   "Transmit Coil Type"},
    { 0x0018, 0x9052, dcm::VR_FD,   "Spectral Width"},
    { 0x0018, 0x9053, dcm::VR_FD,   "Chemical Shift Reference"},
    { 0x0018, 0x9054, dcm::VR_CS,   "Volume Localization Technique"},
    { 0x0018, 0x9058, dcm::VR_US,   "MR Acquisition Frequency Encoding Steps"},
    { 0x0018, 0x9059, dcm::VR_CS,   "De-coupling"},
    { 0x0018, 0x9060, dcm::VR_CS,   "De-coupled Nucleus"},
    { 0x0018, 0x9061, dcm::VR_FD,   "De-coupling Frequency"},
    { 0x0018, 0x9062, dcm::VR_CS,   "De-coupling Method"},
    { 0x0018, 0x9063, dcm::VR_FD,   "De-coupling Chemical Shift Reference"},
    { 0x0018, 0x9064, dcm::VR_CS,   "k-space Filtering"},
    { 0x0018, 0x9065, dcm::VR_CS,   "Time Domain Filtering"},
    { 0x0018, 0x9066, dcm::VR_US,   "Number of Zero fills"},
    { 0x0018, 0x9067, dcm::VR_CS,   "Baseline Correction"},
    { 0x0018, 0x9069, dcm::VR_FD,   "Parallel Reduction Factor In-plane"},
    { 0x0018, 0x9070, dcm::VR_FD,   "Cardiac R-R Interval Specified"},
    { 0x0018, 0x9073, dcm::VR_FD,   "Acquisition Duration"},
    { 0x0018, 0x9074, dcm::VR_DT,   "Frame Acquisition Datetime"},
    { 0x0018, 0x9075, dcm::VR_CS,   "Diffusion Directionality"},
    { 0x0018, 0x9076, dcm::VR_SQ,   "Diffusion Gradient Direction Sequence"},
    { 0x0018, 0x9077, dcm::VR_CS,   "Parallel Acquisition"},
    { 0x0018, 0x9078, dcm::VR_CS,   "Parallel Acquisition Technique"},
    { 0x0018, 0x9079, dcm::VR_FD,   "Inversion Times"},
    { 0x0018, 0x9080, dcm::VR_ST,   "Metabolite Map Description"},
    { 0x0018, 0x9081, dcm::VR_CS,   "Partial Fourier"},
    { 0x0018, 0x9082, dcm::VR_FD,   "Effective Echo Time"},
    { 0x0018, 0x9084, dcm::VR_SQ,   "Chemical Shift Sequence"},
    { 0x0018, 0x9085, dcm::VR_CS,   "Cardiac Signal Source"},
    { 0x0018, 0x9087, dcm::VR_FD,   "Diffusion b-value"},
    { 0x0018, 0x9089, dcm::VR_FD,   "Diffusion Gradient Orientation"},
    { 0x0018, 0x9090, dcm::VR_FD,   "Velocity Encoding Direction"},
    { 0x0018, 0x9091, dcm::VR_FD,   "Velocity Encoding Minimum Value"},
    { 0x0018, 0x9093, dcm::VR_US,   "Number of k-Space Trajectories"},
    { 0x0018, 0x9094, dcm::VR_CS,   "Coverage of k-Space"},
    { 0x0018, 0x9095, dcm::VR_UL,   "Spectroscopy Acquisition Phase Rows"},
    { 0x0018, 0x9098, dcm::VR_FD,   "Transmitter Frequency"},
    { 0x0018, 0x9100, dcm::VR_CS,   "Resonant Nucleus"},
    { 0x0018, 0x9101, dcm::VR_CS,   "Frequency Correction"},
    { 0x0018, 0x9103, dcm::VR_SQ,   "MR Spectroscopy FOV/Geometry Sequence"},
    { 0x0018, 0x9104, dcm::VR_FD,   "Slab Thickness"},
    { 0x0018, 0x9105, dcm::VR_FD,   "Slab Orientation"},
    { 0x0018, 0x9106, dcm::VR_FD,   "Mid Slab Position"},
    { 0x0018, 0x9107, dcm::VR_SQ,   "MR Spatial Saturation Sequence"},
    { 0x0018, 0x9112, dcm::VR_SQ,   "MR Timing and Related Parameters Sequence"},
    { 0x0018, 0x9114, dcm::VR_SQ,   "MR Echo Sequence"},
    { 0x0018, 0x9115, dcm::VR_SQ,   "MR Modifier Sequence"},
    { 0x0018, 0x9117, dcm::VR_SQ,   "MR Diffusion Sequence"},
    { 0x0018, 0x9118, dcm::VR_SQ,   "Cardiac Trigger Sequence"},
    { 0x0018, 0x9119, dcm::VR_SQ,   "MR Averages Sequence"},
    { 0x0018, 0x9125, dcm::VR_SQ,   "MR FOV/Geometry Sequence"},
    { 0x0018, 0x9126, dcm::VR_SQ,   "Volume Localization Sequence"},
    { 0x0018, 0x9127, dcm::VR_UL,   "Spectroscopy Acquisition Data Columns"},
    { 0x0018, 0x9147, dcm::VR_CS,   "Diffusion Anisotropy Type"},
    { 0x0018, 0x9151, dcm::VR_DT,   "Frame Reference Datetime"},
    { 0x0018, 0x9152, dcm::VR_SQ,   "MR Metabolite Map Sequence"},
    { 0x0018, 0x9155, dcm::VR_FD,   "Parallel Reduction Factor out-of-plane"},
    { 0x0018, 0x9159, dcm::VR_UL,   "Spectroscopy Acquisition Out-of-plane Phase Steps"},
    { 0x0018, 0x9166, dcm::VR_CS,   "Bulk Motion Status"},
    { 0x0018, 0x9168, dcm::VR_FD,   "Parallel Reduction Factor Second In-plane"},
    { 0x0018, 0x9169, dcm::VR_CS,   "Cardiac Beat Rejection Technique"},
    { 0x0018, 0x9170, dcm::VR_CS,   "Respiratory Motion Compensation Technique"},
    { 0x0018, 0x9171, dcm::VR_CS,   "Respiratory Signal Source"},
    { 0x0018, 0x9172, dcm::VR_CS,   "Bulk Motion Compensation Technique"},
    { 0x0018, 0x9173, dcm::VR_CS,   "Bulk Motion Signal Source"},
    { 0x0018, 0x9174, dcm::VR_CS,   "Applicable Safety Standard Agency"},
    { 0x0018, 0x9175, dcm::VR_LO,   "Applicable Safety Standard Description"},
    { 0x0018, 0x9176, dcm::VR_SQ,   "Operating Mode Sequence"},
    { 0x0018, 0x9177, dcm::VR_CS,   "Operating Mode Type"},
    { 0x0018, 0x9178, dcm::VR_CS,   "Operating Mode"},
    { 0x0018, 0x9179, dcm::VR_CS,   "Specific Absorption Rate Definition"},
    { 0x0018, 0x9180, dcm::VR_CS,   "Gradient Output Type"},
    { 0x0018, 0x9181, dcm::VR_FD,   "Specific Absorption Rate Value"},
    { 0x0018, 0x9182, dcm::VR_FD,   "Gradient Output"},
    { 0x0018, 0x9183, dcm::VR_CS,   "Flow Compensation Direction"},
    { 0x0018, 0x9184, dcm::VR_FD,   "Tagging Delay"},
    { 0x0018, 0x9195, dcm::VR_FD,   "Chemical Shifts Minimum Integration Limit"},
    { 0x0018, 0x9196, dcm::VR_FD,   "Chemical Shifts Maximum Integration Limit"},
    { 0x0018, 0x9197, dcm::VR_SQ,   "MR Velocity Encoding Sequence"},
    { 0x0018, 0x9198, dcm::VR_CS,   "First Order Phase Correction"},
    { 0x0018, 0x9199, dcm::VR_CS,   "Water Referenced Phase Correction"},
    { 0x0018, 0x9200, dcm::VR_CS,   "MR Spectroscopy Acquisition Type"},
    { 0x0018, 0x9214, dcm::VR_CS,   "Respiratory Cycle Position"},
    { 0x0018, 0x9217, dcm::VR_FD,   "Velocity Encoding Maximum Value"},
    { 0x0018, 0x9218, dcm::VR_SS,   "Tag Spacing Second Dimension"},
    { 0x0018, 0x9219, dcm::VR_SS,   "Tag Angle Second Axis"},
    { 0x0018, 0x9220, dcm::VR_FD,   "Frame Acquisition Duration"},
    { 0x0018, 0x9226, dcm::VR_SQ,   "MR Image Frame Type Sequence"},
    { 0x0018, 0x9227, dcm::VR_SQ,   "MR Spectroscopy Frame Type Sequence"},
    { 0x0018, 0x9231, dcm::VR_US,   "MR Acquisition Phase Encoding Steps in-plane"},
    { 0x0018, 0x9232, dcm::VR_US,   "MR Acquisition Phase Encoding Steps out-of-plane"},
    { 0x0018, 0x9234, dcm::VR_UL,   "Spectroscopy Acquisition Phase Columns"},
    { 0x0018, 0x9236, dcm::VR_CS,   "Cardiac Cycle Position"},
    { 0x0018, 0x9239, dcm::VR_SQ,   "Specific Absorption Rate Sequence"},
    { 0x0018, 0xA001, dcm::VR_SQ,   "Contributing Equipment Sequence"},
    { 0x0018, 0xA002, dcm::VR_DT,   "Contribution DateTime"},
    { 0x0018, 0xA003, dcm::VR_ST,   "Contribution Description"},
};

const int TAG_TABLE_0018_SIZE = sizeof( TAG_TABLE_0018 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0020[] =
{
    { 0x0020, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0020, 0x000D, dcm::VR_UI,   "Study Instance UID"},
    { 0x0020, 0x000E, dcm::VR_UI,   "Series Instance UID"},
    { 0x0020, 0x0010, dcm::VR_SH,   "Study ID"},
    { 0x0020, 0x0011, dcm::VR_IS,   "Series Number"},
    { 0x0020, 0x0012, dcm::VR_IS,   "Acquisition Number"},
    { 0x0020, 0x0013, dcm::VR_IS,   "Instance Number"},
    { 0x0020, 0x0019, dcm::VR_IS,   "Item Number"},
    { 0x0020, 0x0020, dcm::VR_CS,   "Patient Orientation"},
    { 0x0020, 0x0022, dcm::VR_IS,   "Overlay Number"},
    { 0x0020, 0x0024, dcm::VR_IS,   "Curve Number"},
    { 0x0020, 0x0026, dcm::VR_IS,   "Lookup Table Number"},
    { 0x0020, 0x0032, dcm::VR_DS,   "Image Position (Patient)"},
    { 0x0020, 0x0037, dcm::VR_DS,   "Image Orientation (Patient)"},
    { 0x0020, 0x0052, dcm::VR_UI,   "Frame of Reference UID"},
    { 0x0020, 0x0060, dcm::VR_CS,   "Laterality"},
    { 0x0020, 0x0062, dcm::VR_CS,   "Image Laterality"},
    { 0x0020, 0x0100, dcm::VR_IS,   "Temporal Position Identifier"},
    { 0x0020, 0x0105, dcm::VR_IS,   "Number of Temporal Positions"},
    { 0x0020, 0x0110, dcm::VR_DS,   "Temporal Resolution"},
    { 0x0020, 0x0200, dcm::VR_UI,   "Synchronization Frame of Reference UID"},
    { 0x0020, 0x1000, dcm::VR_IS,   "Series in Study"},
    { 0x0020, 0x1002, dcm::VR_IS,   "Images in Acquisition"},
    { 0x0020, 0x1004, dcm::VR_IS,   "Acquisitions in Study"},
    { 0x0020, 0x1040, dcm::VR_LO,   "Position Reference Indicator"},
    { 0x0020, 0x1041, dcm::VR_DS,   "Slice Location"},
    { 0x0020, 0x1070, dcm::VR_IS,   "Other Study Numbers"},
    { 0x0020, 0x1200, dcm::VR_IS,   "Number of Patient Related Studies"},
    { 0x0020, 0x1202, dcm::VR_IS,   "Number of Patient Related Series"},
    { 0x0020, 0x1204, dcm::VR_IS,   "Number of Patient Related Instances"},
    { 0x0020, 0x1206, dcm::VR_IS,   "Number of Study Related Series"},
    { 0x0020, 0x1208, dcm::VR_IS,   "Number of Study Related Instances"},
    { 0x0020, 0x1209, dcm::VR_IS,   "Number of Series Related Instances"},
    { 0x0020, 0x4000, dcm::VR_LT,   "Image Comments"},
    { 0x0020, 0x9056, dcm::VR_SH,   "Stack ID"},
    { 0x0020, 0x9057, dcm::VR_UL,   "In-Stack Position Number"},
    { 0x0020, 0x9071, dcm::VR_SQ,   "Frame Anatomy Sequence"},
    { 0x0020, 0x9072, dcm::VR_CS,   "Frame Laterality"},
    { 0x0020, 0x9111, dcm::VR_SQ,   "Frame Content Sequence"},
    { 0x0020, 0x9113, dcm::VR_SQ,   "Plane Position Sequence"},
    { 0x0020, 0x9116, dcm::VR_SQ,   "Plane Orientation Sequence"},
    { 0x0020, 0x9128, dcm::VR_UL,   "Temporal Position Index"},
    { 0x0020, 0x9153, dcm::VR_FD,   "Trigger Delay Time"},
    { 0x0020, 0x9156, dcm::VR_US,   "Frame Acquisition Number"},
    { 0x0020, 0x9157, dcm::VR_UL,   "Dimension Index Values"},
    { 0x0020, 0x9158, dcm::VR_LT,   "Frame Comments"},
    { 0x0020, 0x9161, dcm::VR_UI,   "Concatenation UID"},
    { 0x0020, 0x9162, dcm::VR_US,   "In-concatenation Number"},
    { 0x0020, 0x9163, dcm::VR_US,   "In-concatenation Total Number"},
    { 0x0020, 0x9164, dcm::VR_UI,   "Dimension Organization UID"},
    { 0x0020, 0x9165, dcm::VR_AT,   "Dimension Index Pointer"},
    { 0x0020, 0x9167, dcm::VR_AT,   "Functional Group Pointer"},
    { 0x0020, 0x9213, dcm::VR_LO,   "Dimension Index Private Creator"},
    { 0x0020, 0x9221, dcm::VR_SQ,   "Dimension Organization Sequence"},
    { 0x0020, 0x9222, dcm::VR_SQ,   "Dimension Index Sequence"},
    { 0x0020, 0x9228, dcm::VR_UL,   "Concatenation Frame Offset Number"},
    { 0x0020, 0x9238, dcm::VR_LO,   "Functional Group Private Creator"},
};

const int TAG_TABLE_0020_SIZE = sizeof( TAG_TABLE_0020 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0028[] =
{
    { 0x0028, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0028, 0x0002, dcm::VR_US,   "Samples per Pixel"},
    { 0x0028, 0x0004, dcm::VR_CS,   "Photometric Interpretation"},
    { 0x0028, 0x0006, dcm::VR_US,   "Planar Configuration"},
    { 0x0028, 0x0008, dcm::VR_IS,   "Number of Frames"},
    { 0x0028, 0x0009, dcm::VR_AT,   "Frame Increment Pointer"},
    { 0x0028, 0x0010, dcm::VR_US,   "Rows"},
    { 0x0028, 0x0011, dcm::VR_US,   "Columns"},
    { 0x0028, 0x0012, dcm::VR_US,   "Planes"},
    { 0x0028, 0x0014, dcm::VR_US,   "Ultrasound Color Data Present"},
    { 0x0028, 0x0030, dcm::VR_DS,   "Pixel Spacing"},
    { 0x0028, 0x0031, dcm::VR_DS,   "Zoom Factor"},
    { 0x0028, 0x0032, dcm::VR_DS,   "Zoom Center"},
    { 0x0028, 0x0034, dcm::VR_IS,   "Pixel Aspect Ratio"},
    { 0x0028, 0x0051, dcm::VR_CS,   "Corrected Image"},
    { 0x0028, 0x0100, dcm::VR_US,   "Bits Allocated"},
    { 0x0028, 0x0101, dcm::VR_US,   "Bits Stored"},
    { 0x0028, 0x0102, dcm::VR_US,   "High Bit"},
    { 0x0028, 0x0103, dcm::VR_US,   "Pixel Representation"},
    { 0x0028, 0x0106, dcm::VR_US,   "Smallest Image Pixel Value"},
    { 0x0028, 0x0107, dcm::VR_US,   "Largest Image Pixel Value"},
    { 0x0028, 0x0108, dcm::VR_US,   "Smallest Pixel Value in Series"},
    { 0x0028, 0x0109, dcm::VR_US,   "Largest Pixel Value in Series"},
    { 0x0028, 0x0110, dcm::VR_US,   "Smallest Image Pixel Value in Plane"},
    { 0x0028, 0x0111, dcm::VR_US,   "Largest Image Pixel Value in Plane"},
    { 0x0028, 0x0120, dcm::VR_US,   "Pixel Padding Value"},
    { 0x0028, 0x0300, dcm::VR_CS,   "Quality Control Image"},
    { 0x0028, 0x0301, dcm::VR_CS,   "Burned In Annotation"},
    { 0x0028, 0x1040, dcm::VR_CS,   "Pixel Intensity Relationship"},
    { 0x0028, 0x1041, dcm::VR_SS,   "Pixel Intensity Relationship Sign"},
    { 0x0028, 0x1050, dcm::VR_DS,   "Window Center"},
    { 0x0028, 0x1051, dcm::VR_DS,   "Window Width"},
    { 0x0028, 0x1052, dcm::VR_DS,   "Rescale Intercept"},
    { 0x0028, 0x1053, dcm::VR_DS,   "Rescale Slope"},
    { 0x0028, 0x1054, dcm::VR_LO,   "Rescale Type"},
    { 0x0028, 0x1055, dcm::VR_LO,   "Window Center & Width Explanation"},
    { 0x0028, 0x1090, dcm::VR_CS,   "Recommended Viewing Mode"},
    { 0x0028, 0x1101, dcm::VR_US,   "Red Palette Color Lookup Table Descriptor"},
    { 0x0028, 0x1102, dcm::VR_US,   "Green Palette Color Lookup Table Descriptor"},
    { 0x0028, 0x1103, dcm::VR_US,   "Blue Palette Color Lookup Table Descriptor"},
    { 0x0028, 0x1199, dcm::VR_UI,   "Palette Color Lookup Table UID"},
    { 0x0028, 0x1201, dcm::VR_OW,   "Red Palette Color Lookup Table Data"},
    { 0x0028, 0x1202, dcm::VR_OW,   "Green Palette Color Lookup Table Data"},
    { 0x0028, 0x1203, dcm::VR_OW,   "Blue Palette Color Lookup Table Data"},
    { 0x0028, 0x1221, dcm::VR_OW,   "Segmented Red Palette Color Lookup Table Data"},
    { 0x0028, 0x1222, dcm::VR_OW,   "Segmented Green Palette Color Lookup Table Data"},
    { 0x0028, 0x1223, dcm::VR_OW,   "Segmented Blue Palette Color Lookup Table Data"},
    { 0x0028, 0x1300, dcm::VR_CS,   "Implant Present"},
    { 0x0028, 0x1350, dcm::VR_CS,   "Partial View"},
    { 0x0028, 0x1351, dcm::VR_ST,   "Partial View Description"},
    { 0x0028, 0x2110, dcm::VR_CS,   "Lossy Image Compression"},
    { 0x0028, 0x2112, dcm::VR_DS,   "Lossy Image Compression Ratio"},
    { 0x0028, 0x3000, dcm::VR_SQ,   "Modality LUT Sequence"},
    { 0x0028, 0x3002, dcm::VR_US,   "LUT Descriptor"},
    { 0x0028, 0x3003, dcm::VR_LO,   "LUT Explanation"},
    { 0x0028, 0x3004, dcm::VR_LO,   "Modality LUT Type"},
    { 0x0028, 0x3006, dcm::VR_US,   "LUT Data"},
    { 0x0028, 0x3010, dcm::VR_SQ,   "VOI LUT Sequence"},
    { 0x0028, 0x3110, dcm::VR_SQ,   "Softcopy VOI LUT Sequence"},
    { 0x0028, 0x5000, dcm::VR_SQ,   "Bi-Plane Acquisition Sequence"},
    { 0x0028, 0x6010, dcm::VR_US,   "Representative Frame Number"},
    { 0x0028, 0x6020, dcm::VR_US,   "Frame Numbers of Interest (FOI)"},
    { 0x0028, 0x6022, dcm::VR_LO,   "Frame(s) of Interest Description"},
    { 0x0028, 0x6040, dcm::VR_US,   "R Wave Pointer"},
    { 0x0028, 0x6100, dcm::VR_SQ,   "Mask Subtraction Sequence"},
    { 0x0028, 0x6101, dcm::VR_CS,   "Mask Operation"},
    { 0x0028, 0x6102, dcm::VR_US,   "Applicable Frame Range"},
    { 0x0028, 0x6110, dcm::VR_US,   "Mask Frame Numbers"},
    { 0x0028, 0x6112, dcm::VR_US,   "Contrast Frame Averaging"},
    { 0x0028, 0x6114, dcm::VR_FL,   "Mask Sub-pixel Shift"},
    { 0x0028, 0x6120, dcm::VR_SS,   "TID Offset"},
    { 0x0028, 0x6190, dcm::VR_ST,   "Mask Operation Explanation"},
    { 0x0028, 0x9001, dcm::VR_UL,   "Data Point Rows"},
    { 0x0028, 0x9002, dcm::VR_UL,   "Data Point Columns"},
    { 0x0028, 0x9003, dcm::VR_CS,   "Signal Domain Columns"},
    { 0x0028, 0x9099, dcm::VR_US,   "Largest Monochrome Pixel Value"},
    { 0x0028, 0x9108, dcm::VR_CS,   "Data Representation"},
    { 0x0028, 0x9110, dcm::VR_SQ,   "Pixel Measures Sequence"},
    { 0x0028, 0x9132, dcm::VR_SQ,   "Frame VOI LUT Sequence"},
    { 0x0028, 0x9145, dcm::VR_SQ,   "Pixel Value Transformation Sequence"},
    { 0x0028, 0x9235, dcm::VR_CS,   "Signal Domain Rows"},
};

const int TAG_TABLE_0028_SIZE = sizeof( TAG_TABLE_0028 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0032[] =
{
    { 0x0032, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0032, 0x000A, dcm::VR_CS,   "Study Status ID"},
    { 0x0032, 0x000C, dcm::VR_CS,   "Study Priority ID"},
    { 0x0032, 0x0012, dcm::VR_LO,   "Study ID Issuer"},
    { 0x0032, 0x0032, dcm::VR_DA,   "Study Verified Date"},
    { 0x0032, 0x0033, dcm::VR_TM,   "Study Verified Time"},
    { 0x0032, 0x0034, dcm::VR_DA,   "Study Read Date"},
    { 0x0032, 0x0035, dcm::VR_TM,   "Study Read Time"},
    { 0x0032, 0x1000, dcm::VR_DA,   "Scheduled Study Start Date"},
    { 0x0032, 0x1001, dcm::VR_TM,   "Scheduled Study Start Time"},
    { 0x0032, 0x1010, dcm::VR_DA,   "Scheduled Study Stop Date"},
    { 0x0032, 0x1011, dcm::VR_TM,   "Scheduled Study Stop Time"},
    { 0x0032, 0x1020, dcm::VR_LO,   "Scheduled Study Location"},
    { 0x0032, 0x1021, dcm::VR_AE,   "Scheduled Study Location AE Title(s)"},
    { 0x0032, 0x1030, dcm::VR_LO,   "Reason for Study"},
    { 0x0032, 0x1031, dcm::VR_SQ,   "Requesting Physician Identification Sequence"},
    { 0x0032, 0x1032, dcm::VR_PN,   "Requesting Physician"},
    { 0x0032, 0x1033, dcm::VR_LO,   "Requesting Service"},
    { 0x0032, 0x1040, dcm::VR_DA,   "Study Arrival Date"},
    { 0x0032, 0x1041, dcm::VR_TM,   "Study Arrival Time"},
    { 0x0032, 0x1050, dcm::VR_DA,   "Study Completion Date"},
    { 0x0032, 0x1051, dcm::VR_TM,   "Study Completion Time"},
    { 0x0032, 0x1055, dcm::VR_CS,   "Study Component Status ID"},
    { 0x0032, 0x1060, dcm::VR_LO,   "Requested Procedure Description"},
    { 0x0032, 0x1064, dcm::VR_SQ,   "Requested Procedure Code Sequence"},
    { 0x0032, 0x1070, dcm::VR_LO,   "Requested Contrast Agent"},
    { 0x0032, 0x4000, dcm::VR_LT,   "Study Comments"},
};

const int TAG_TABLE_0032_SIZE = sizeof( TAG_TABLE_0032 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0038[] =
{
    { 0x0038, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0038, 0x0004, dcm::VR_SQ,   "Referenced Patient Alias Sequence"},
    { 0x0038, 0x0008, dcm::VR_CS,   "Visit Status ID"},
    { 0x0038, 0x0010, dcm::VR_LO,   "Admission ID"},
    { 0x0038, 0x0011, dcm::VR_LO,   "Issuer of Admission ID"},
    { 0x0038, 0x0016, dcm::VR_LO,   "Route of Admissions"},
    { 0x0038, 0x001A, dcm::VR_DA,   "Scheduled Admission Date"},
    { 0x0038, 0x001B, dcm::VR_TM,   "Scheduled Admission Time"},
    { 0x0038, 0x001C, dcm::VR_DA,   "Scheduled Discharge Date"},
    { 0x0038, 0x001D, dcm::VR_TM,   "Scheduled Discharge Time"},
    { 0x0038, 0x001E, dcm::VR_LO,   "Scheduled Patient Institution Residence"},
    { 0x0038, 0x0020, dcm::VR_DA,   "Admitting Date"},
    { 0x0038, 0x0021, dcm::VR_TM,   "Admitting Time"},
    { 0x0038, 0x0030, dcm::VR_DA,   "Discharge Date"},
    { 0x0038, 0x0032, dcm::VR_TM,   "Discharge Time"},
    { 0x0038, 0x0040, dcm::VR_LO,   "Discharge Diagnosis Description"},
    { 0x0038, 0x0044, dcm::VR_SQ,   "Discharge Diagnosis Code Sequence"},
    { 0x0038, 0x0050, dcm::VR_LO,   "Special Needs"},
    { 0x0038, 0x0300, dcm::VR_LO,   "Current Patient Location"},
    { 0x0038, 0x0400, dcm::VR_LO,   "Patient's Institution Residence"},
    { 0x0038, 0x0500, dcm::VR_LO,   "Patient State"},
    { 0x0038, 0x4000, dcm::VR_LT,   "Visit Comments"},
};

const int TAG_TABLE_0038_SIZE = sizeof( TAG_TABLE_0038 ) / sizeof( TagTable );


const TagTable TAG_TABLE_003A[] =
{
    { 0x003A, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x003A, 0x0004, dcm::VR_CS,   "Waveform Originality"},
    { 0x003A, 0x0005, dcm::VR_US,   "Number of Waveform Channels"},
    { 0x003A, 0x0010, dcm::VR_UL,   "Number of Waveform Samples"},
    { 0x003A, 0x001A, dcm::VR_DS,   "Sampling Frequency"},
    { 0x003A, 0x0020, dcm::VR_SH,   "Multiplex Group Label"},
    { 0x003A, 0x0200, dcm::VR_SQ,   "Channel Definition Sequence"},
    { 0x003A, 0x0202, dcm::VR_IS,   "Waveform Channel Number"},
    { 0x003A, 0x0203, dcm::VR_SH,   "Channel Label"},
    { 0x003A, 0x0205, dcm::VR_CS,   "Channel Status"},
    { 0x003A, 0x0208, dcm::VR_SQ,   "Channel Source Sequence"},
    { 0x003A, 0x0209, dcm::VR_SQ,   "Channel Source Modifiers Sequence"},
    { 0x003A, 0x020A, dcm::VR_SQ,   "Source Waveform Sequence"},
    { 0x003A, 0x020C, dcm::VR_LO,   "Channel Derivation Description"},
    { 0x003A, 0x0210, dcm::VR_DS,   "Channel Sensitivity"},
    { 0x003A, 0x0211, dcm::VR_SQ,   "Channel Sensitivity Units Sequence"},
    { 0x003A, 0x0212, dcm::VR_DS,   "Channel Sensitivity Correction Factor"},
    { 0x003A, 0x0213, dcm::VR_DS,   "Channel Baseline"},
    { 0x003A, 0x0214, dcm::VR_DS,   "Channel Time Skew"},
    { 0x003A, 0x0215, dcm::VR_DS,   "Channel Sample Skew"},
    { 0x003A, 0x0218, dcm::VR_DS,   "Channel Offset"},
    { 0x003A, 0x021A, dcm::VR_US,   "Waveform Bits Stored"},
    { 0x003A, 0x0220, dcm::VR_DS,   "Filter Low Frequency"},
    { 0x003A, 0x0221, dcm::VR_DS,   "Filter High Frequency"},
    { 0x003A, 0x0222, dcm::VR_DS,   "Notch Filter Frequency"},
    { 0x003A, 0x0223, dcm::VR_DS,   "Notch Filter Bandwidth"},
};

const int TAG_TABLE_003A_SIZE = sizeof( TAG_TABLE_003A ) / sizeof( TagTable );


const TagTable TAG_TABLE_0040[] =
{
    { 0x0040, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0040, 0x0001, dcm::VR_AE,   "Scheduled Station AE Title"},
    { 0x0040, 0x0002, dcm::VR_DA,   "Scheduled Procedure Step Start Date"},
    { 0x0040, 0x0003, dcm::VR_TM,   "Scheduled Procedure Step Start Time"},
    { 0x0040, 0x0004, dcm::VR_DA,   "Scheduled Procedure Step End Date"},
    { 0x0040, 0x0005, dcm::VR_TM,   "Scheduled Procedure Step End Time"},
    { 0x0040, 0x0006, dcm::VR_PN,   "Scheduled Performing Physician's Name"},
    { 0x0040, 0x0007, dcm::VR_LO,   "Scheduled Procedure Step Description"},
    { 0x0040, 0x0008, dcm::VR_SQ,   "Scheduled Protocol Code Sequence"},
    { 0x0040, 0x0009, dcm::VR_SH,   "Scheduled Procedure Step ID"},
    { 0x0040, 0x000A, dcm::VR_SQ,   "Stage Code Sequence"},
    { 0x0040, 0x000B, dcm::VR_SQ,   "Scheduled Performing Physician Identification Sequence"},
    { 0x0040, 0x0010, dcm::VR_SH,   "Scheduled Station Name"},
    { 0x0040, 0x0011, dcm::VR_SH,   "Scheduled Procedure Step Location"},
    { 0x0040, 0x0012, dcm::VR_LO,   "Pre-Medication"},
    { 0x0040, 0x0020, dcm::VR_CS,   "Scheduled Procedure Step Status"},
    { 0x0040, 0x0100, dcm::VR_SQ,   "Scheduled Procedure Step Sequence"},
    { 0x0040, 0x0220, dcm::VR_SQ,   "Referenced Non-Image Composite SOP Instance Sequence"},
    { 0x0040, 0x0241, dcm::VR_AE,   "Performed Station AE Title"},
    { 0x0040, 0x0242, dcm::VR_SH,   "Performed Station Name"},
    { 0x0040, 0x0243, dcm::VR_SH,   "Performed Location"},
    { 0x0040, 0x0244, dcm::VR_DA,   "Performed Procedure Step Start Date"},
    { 0x0040, 0x0245, dcm::VR_TM,   "Performed Procedure Step Start Time"},
    { 0x0040, 0x0250, dcm::VR_DA,   "Performed Procedure Step End Date"},
    { 0x0040, 0x0251, dcm::VR_TM,   "Performed Procedure Step End Time"},
    { 0x0040, 0x0252, dcm::VR_CS,   "Performed Procedure Step Status"},
    { 0x0040, 0x0253, dcm::VR_SH,   "Performed Procedure Step ID"},
    { 0x0040, 0x0254, dcm::VR_LO,   "Performed Procedure Step Description"},
    { 0x0040, 0x0255, dcm::VR_LO,   "Performed Procedure Type Description"},
    { 0x0040, 0x0260, dcm::VR_SQ,   "Performed Protocol Code Sequence"},
    { 0x0040, 0x0270, dcm::VR_SQ,   "Scheduled Step Attributes Sequence"},
    { 0x0040, 0x0275, dcm::VR_SQ,   "Request Attributes Sequence"},
    { 0x0040, 0x0280, dcm::VR_ST,   "Comments on the Performed Procedure Step"},
    { 0x0040, 0x0281, dcm::VR_SQ,   "Performed Procedure Step Discontinuation Reason Code Sequence"},
    { 0x0040, 0x0293, dcm::VR_SQ,   "Quantity Sequence"},
    { 0x0040, 0x0294, dcm::VR_DS,   "Quantity"},
    { 0x0040, 0x0295, dcm::VR_SQ,   "Measuring Units Sequence"},
    { 0x0040, 0x0296, dcm::VR_SQ,   "Billing Item Sequence"},
    { 0x0040, 0x0300, dcm::VR_US,   "Total Time of Fluoroscopy"},
    { 0x0040, 0x0301, dcm::VR_US,   "Total Number of Exposures"},
    { 0x0040, 0x0302, dcm::VR_US,   "Entrance Dose"},
    { 0x0040, 0x0303, dcm::VR_US,   "Exposed Area"},
    { 0x0040, 0x0306, dcm::VR_DS,   "Distance Source to Entrance"},
    { 0x0040, 0x030E, dcm::VR_SQ,   "Exposure Dose Sequence"},
    { 0x0040, 0x0310, dcm::VR_ST,   "Comments on Radiation Dose"},
    { 0x0040, 0x0312, dcm::VR_DS,   "X-Ray Output"},
    { 0x0040, 0x0314, dcm::VR_DS,   "Half Value Layer"},
    { 0x0040, 0x0316, dcm::VR_DS,   "Organ Dose"},
    { 0x0040, 0x0318, dcm::VR_CS,   "Organ Exposed"},
    { 0x0040, 0x0320, dcm::VR_SQ,   "Billing Procedure Step Sequence"},
    { 0x0040, 0x0321, dcm::VR_SQ,   "Film Consumption Sequence"},
    { 0x0040, 0x0324, dcm::VR_SQ,   "Billing Supplies and Devices Sequence"},
    { 0x0040, 0x0330, dcm::VR_SQ,   "Referenced Procedure Step Sequence"},
    { 0x0040, 0x0340, dcm::VR_SQ,   "Performed Series Sequence"},
    { 0x0040, 0x0400, dcm::VR_LT,   "Comments on the Scheduled Procedure Step"},
    { 0x0040, 0x050A, dcm::VR_LO,   "Specimen Accession Number"},
    { 0x0040, 0x0550, dcm::VR_SQ,   "Specimen Sequence"},
    { 0x0040, 0x0551, dcm::VR_LO,   "Specimen Identifier"},
    { 0x0040, 0x0555, dcm::VR_SQ,   "Acquisition Context Sequence"},
    { 0x0040, 0x0556, dcm::VR_ST,   "Acquisition Context Description"},
    { 0x0040, 0x059A, dcm::VR_SQ,   "Specimen Type Code Sequence"},
    { 0x0040, 0x06FA, dcm::VR_LO,   "Slide Identifier"},
    { 0x0040, 0x071A, dcm::VR_SQ,   "Image Center Point Coordinates Sequence"},
    { 0x0040, 0x072A, dcm::VR_DS,   "X offset in Slide Coordinate System"},
    { 0x0040, 0x073A, dcm::VR_DS,   "Y offset in Slide Coordinate System"},
    { 0x0040, 0x074A, dcm::VR_DS,   "Z offset in Slide Coordinate System"},
    { 0x0040, 0x08D8, dcm::VR_SQ,   "Pixel Spacing Sequence"},
    { 0x0040, 0x08DA, dcm::VR_SQ,   "Coordinate System Axis Code Sequence"},
    { 0x0040, 0x08EA, dcm::VR_SQ,   "Measurement Units Code Sequence"},
    { 0x0040, 0x1001, dcm::VR_SH,   "Requested Procedure ID"},
    { 0x0040, 0x1002, dcm::VR_LO,   "Reason for the Requested Procedure"},
    { 0x0040, 0x1003, dcm::VR_SH,   "Requested Procedure Priority"},
    { 0x0040, 0x1004, dcm::VR_LO,   "Patient Transport Arrangements"},
    { 0x0040, 0x1005, dcm::VR_LO,   "Requested Procedure Location"},
    { 0x0040, 0x1006, dcm::VR_SH,   "Placer Order Number / Procedure"},
    { 0x0040, 0x1007, dcm::VR_SH,   "Filler Order Number / Procedure"},
    { 0x0040, 0x1008, dcm::VR_LO,   "Confidentiality Code"},
    { 0x0040, 0x1009, dcm::VR_SH,   "Reporting Priority"},
    { 0x0040, 0x1010, dcm::VR_PN,   "Names of Intended Recipients of Results"},
    { 0x0040, 0x1011, dcm::VR_SQ,   "Intended Recipients of Results Identification Sequence"},
    { 0x0040, 0x1101, dcm::VR_SQ,   "Person Identification Code Sequence"},
    { 0x0040, 0x1102, dcm::VR_ST,   "Person's Address"},
    { 0x0040, 0x1103, dcm::VR_LO,   "Person's Telephone Numbers"},
    { 0x0040, 0x1400, dcm::VR_LT,   "Requested Procedure Comments"},
    { 0x0040, 0x2001, dcm::VR_LO,   "Reason for the Imaging Service Request"},
    { 0x0040, 0x2004, dcm::VR_DA,   "Issue Date of Imaging Service Request"},
    { 0x0040, 0x2005, dcm::VR_TM,   "Issue Time of Imaging Service Request"},
    { 0x0040, 0x2008, dcm::VR_PN,   "Order Entered By"},
    { 0x0040, 0x2009, dcm::VR_SH,   "Order Enterer's Location"},
    { 0x0040, 0x2010, dcm::VR_SH,   "Order Callback Phone Number"},
    { 0x0040, 0x2016, dcm::VR_LO,   "Placer Order Number / Imaging Service Request"},
    { 0x0040, 0x2017, dcm::VR_LO,   "Filler Order Number / Imaging Service Request"},
    { 0x0040, 0x2400, dcm::VR_LT,   "Imaging Service Request Comments"},
    { 0x0040, 0x3001, dcm::VR_LO,   "Confidentiality Constraint on Patient Data Description"},
    { 0x0040, 0x4001, dcm::VR_CS,   "General Purpose Scheduled Procedure Step Status"},
    { 0x0040, 0x4002, dcm::VR_CS,   "General Purpose Performed Procedure Step Status"},
    { 0x0040, 0x4003, dcm::VR_CS,   "General Purpose Scheduled Procedure Step Priority"},
    { 0x0040, 0x4004, dcm::VR_SQ,   "Scheduled Processing Applications Code Sequence"},
    { 0x0040, 0x4005, dcm::VR_DT,   "Scheduled Procedure Step Start Date and Time"},
    { 0x0040, 0x4006, dcm::VR_CS,   "Multiple Copies Flag"},
    { 0x0040, 0x4007, dcm::VR_SQ,   "Performed Processing Applications Code Sequence"},
    { 0x0040, 0x4009, dcm::VR_SQ,   "Human Performer Code Sequence"},
    { 0x0040, 0x4011, dcm::VR_DT,   "Expected Completion Date and Time"},
    { 0x0040, 0x4015, dcm::VR_SQ,   "Resulting General Purpose Performed Procedure Steps Sequence"},
    { 0x0040, 0x4016, dcm::VR_SQ,   "Referenced General Purpose Scheduled Procedure Step Sequence"},
    { 0x0040, 0x4018, dcm::VR_SQ,   "Scheduled Workitem Code Sequence"},
    { 0x0040, 0x4019, dcm::VR_SQ,   "Performed Workitem Code Sequence"},
    { 0x0040, 0x4020, dcm::VR_CS,   "Input Availability Flag"},
    { 0x0040, 0x4021, dcm::VR_SQ,   "Input Information Sequence"},
    { 0x0040, 0x4022, dcm::VR_SQ,   "Relevant Information Sequence"},
    { 0x0040, 0x4023, dcm::VR_UI,   "Referenced General Purpose Scheduled Procedure Step Transaction UID"},
    { 0x0040, 0x4025, dcm::VR_SQ,   "Scheduled Station Name Code Sequence"},
    { 0x0040, 0x4026, dcm::VR_SQ,   "Scheduled Station Class Code Sequence"},
    { 0x0040, 0x4027, dcm::VR_SQ,   "Scheduled Station Geographic Location Code Sequence"},
    { 0x0040, 0x4028, dcm::VR_SQ,   "Performed Station Name Code Sequence"},
    { 0x0040, 0x4029, dcm::VR_SQ,   "Performed Station Class Code Sequence"},
    { 0x0040, 0x4030, dcm::VR_SQ,   "Performed Station Geographic Location Code Sequence"},
    { 0x0040, 0x4031, dcm::VR_SQ,   "Requested Subsequent Workitem Code Sequence"},
    { 0x0040, 0x4032, dcm::VR_SQ,   "Non-DICOM Output Code Sequence"},
    { 0x0040, 0x4033, dcm::VR_SQ,   "Output Information Sequence"},
    { 0x0040, 0x4034, dcm::VR_SQ,   "Scheduled Human Performers Sequence"},
    { 0x0040, 0x4035, dcm::VR_SQ,   "Actual Human Performers Sequence"},
    { 0x0040, 0x4036, dcm::VR_LO,   "Human Performer's Organization"},
    { 0x0040, 0x4037, dcm::VR_PN,   "Human Performer's Name"},
    { 0x0040, 0x8302, dcm::VR_DS,   "Entrance Dose in mGy"},
    { 0x0040, 0x9096, dcm::VR_SQ,   "Real World Value Mapping Sequence"},
    { 0x0040, 0x9210, dcm::VR_SS,   "LUT Label"},
    { 0x0040, 0x9211, dcm::VR_US,   "Real World Value Last Value Mapped"},
    { 0x0040, 0x9212, dcm::VR_FD,   "Real World Value LUT Data"},
    { 0x0040, 0x9216, dcm::VR_US,   "Real World Value First Value Mapped"},
    { 0x0040, 0x9224, dcm::VR_FD,   "Real World Value Intercept"},
    { 0x0040, 0x9225, dcm::VR_FD,   "Real World Value Slope"},
    { 0x0040, 0xA010, dcm::VR_CS,   "Relationship Type"},
    { 0x0040, 0xA027, dcm::VR_LO,   "Verifying Organization"},
    { 0x0040, 0xA030, dcm::VR_DT,   "Verification DateTime"},
    { 0x0040, 0xA032, dcm::VR_DT,   "Observation DateTime"},
    { 0x0040, 0xA040, dcm::VR_CS,   "Value Type"},
    { 0x0040, 0xA043, dcm::VR_SQ,   "Concept Name Code Sequence"},
    { 0x0040, 0xA050, dcm::VR_CS,   "Continuity Of Content"},
    { 0x0040, 0xA073, dcm::VR_SQ,   "Verifying Observer Sequence"},
    { 0x0040, 0xA075, dcm::VR_PN,   "Verifying Observer Name"},
    { 0x0040, 0xA088, dcm::VR_SQ,   "Verifying Observer Identification Code Sequence"},
    { 0x0040, 0xA0B0, dcm::VR_US,   "Referenced Waveform Channels"},
    { 0x0040, 0xA120, dcm::VR_DT,   "DateTime"},
    { 0x0040, 0xA121, dcm::VR_DA,   "Date"},
    { 0x0040, 0xA122, dcm::VR_TM,   "Time"},
    { 0x0040, 0xA123, dcm::VR_PN,   "Person Name"},
    { 0x0040, 0xA124, dcm::VR_UI,   "UID"},
    { 0x0040, 0xA130, dcm::VR_CS,   "Temporal Range Type"},
    { 0x0040, 0xA132, dcm::VR_UL,   "Referenced Sample Positions"},
    { 0x0040, 0xA136, dcm::VR_US,   "Referenced Frame Numbers"},
    { 0x0040, 0xA138, dcm::VR_DS,   "Referenced Time Offsets"},
    { 0x0040, 0xA13A, dcm::VR_DT,   "Referenced Datetime"},
    { 0x0040, 0xA160, dcm::VR_UT,   "Text Value"},
    { 0x0040, 0xA168, dcm::VR_SQ,   "Concept Code Sequence"},
    { 0x0040, 0xA170, dcm::VR_SQ,   "Purpose of Reference Code Sequence"},
    { 0x0040, 0xA180, dcm::VR_US,   "Annotation Group Number"},
    { 0x0040, 0xA195, dcm::VR_SQ,   "Modifier Code Sequence"},
    { 0x0040, 0xA300, dcm::VR_SQ,   "Measured Value Sequence"},
    { 0x0040, 0xA301, dcm::VR_SQ,   "Numeric Value Qualifier Code Sequence"},
    { 0x0040, 0xA30A, dcm::VR_DS,   "Numeric Value"},
    { 0x0040, 0xA360, dcm::VR_SQ,   "Predecessor Documents Sequence"},
    { 0x0040, 0xA370, dcm::VR_SQ,   "Referenced Request Sequence"},
    { 0x0040, 0xA372, dcm::VR_SQ,   "Performed Procedure Code Sequence"},
    { 0x0040, 0xA375, dcm::VR_SQ,   "Current Requested Procedure Evidence Sequence"},
    { 0x0040, 0xA385, dcm::VR_SQ,   "Pertinent Other Evidence Sequence"},
    { 0x0040, 0xA491, dcm::VR_CS,   "Completion Flag"},
    { 0x0040, 0xA492, dcm::VR_LO,   "Completion Flag Description"},
    { 0x0040, 0xA493, dcm::VR_CS,   "Verification Flag"},
    { 0x0040, 0xA504, dcm::VR_SQ,   "Content Template Sequence"},
    { 0x0040, 0xA525, dcm::VR_SQ,   "Identical Documents Sequence"},
    { 0x0040, 0xA730, dcm::VR_SQ,   "Content Sequence"},
    { 0x0040, 0xB020, dcm::VR_SQ,   "Annotation Sequence"},
    { 0x0040, 0xDB00, dcm::VR_CS,   "Template Identifier"},
    { 0x0040, 0xDB73, dcm::VR_UL,   "Referenced Content Item Identifier"},
};

const int TAG_TABLE_0040_SIZE = sizeof( TAG_TABLE_0040 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0050[] =
{
    { 0x0050, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0050, 0x0004, dcm::VR_CS,   "Calibration Image"},
    { 0x0050, 0x0010, dcm::VR_SQ,   "Device Sequence"},
    { 0x0050, 0x0014, dcm::VR_DS,   "Device Length"},
    { 0x0050, 0x0016, dcm::VR_DS,   "Device Diameter"},
    { 0x0050, 0x0017, dcm::VR_CS,   "Device Diameter Units"},
    { 0x0050, 0x0018, dcm::VR_DS,   "Device Volume"},
    { 0x0050, 0x0019, dcm::VR_DS,   "Inter-marker Distance"},
    { 0x0050, 0x0020, dcm::VR_LO,   "Device Description"},
};

const int TAG_TABLE_0050_SIZE = sizeof( TAG_TABLE_0050 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0054[] =
{
    { 0x0054, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0054, 0x0010, dcm::VR_US,   "Energy Window Vector"},
    { 0x0054, 0x0011, dcm::VR_US,   "Number of Energy Windows"},
    { 0x0054, 0x0012, dcm::VR_SQ,   "Energy Window Information Sequence"},
    { 0x0054, 0x0013, dcm::VR_SQ,   "Energy Window Range Sequence"},
    { 0x0054, 0x0014, dcm::VR_DS,   "Energy Window Lower Limit"},
    { 0x0054, 0x0015, dcm::VR_DS,   "Energy Window Upper Limit"},
    { 0x0054, 0x0016, dcm::VR_SQ,   "Radiopharmaceutical Information Sequence"},
    { 0x0054, 0x0017, dcm::VR_IS,   "Residual Syringe Counts"},
    { 0x0054, 0x0018, dcm::VR_SH,   "Energy Window Name"},
    { 0x0054, 0x0020, dcm::VR_US,   "Detector Vector"},
    { 0x0054, 0x0021, dcm::VR_US,   "Number of Detectors"},
    { 0x0054, 0x0022, dcm::VR_SQ,   "Detector Information Sequence"},
    { 0x0054, 0x0030, dcm::VR_US,   "Phase Vector"},
    { 0x0054, 0x0031, dcm::VR_US,   "Number of Phases"},
    { 0x0054, 0x0032, dcm::VR_SQ,   "Phase Information Sequence"},
    { 0x0054, 0x0033, dcm::VR_US,   "Number of Frames in Phase"},
    { 0x0054, 0x0036, dcm::VR_IS,   "Phase Delay"},
    { 0x0054, 0x0038, dcm::VR_IS,   "Pause Between Frames"},
    { 0x0054, 0x0050, dcm::VR_US,   "Rotation Vector"},
    { 0x0054, 0x0051, dcm::VR_US,   "Number of Rotations"},
    { 0x0054, 0x0052, dcm::VR_SQ,   "Rotation Information Sequence"},
    { 0x0054, 0x0053, dcm::VR_US,   "Number of Frames in Rotation"},
    { 0x0054, 0x0060, dcm::VR_US,   "R-R Interval Vector"},
    { 0x0054, 0x0061, dcm::VR_US,   "Number of R-R Intervals"},
    { 0x0054, 0x0062, dcm::VR_SQ,   "Gated Information Sequence"},
    { 0x0054, 0x0063, dcm::VR_SQ,   "Data Information Sequence"},
    { 0x0054, 0x0070, dcm::VR_US,   "Time Slot Vector"},
    { 0x0054, 0x0071, dcm::VR_US,   "Number of Time Slots"},
    { 0x0054, 0x0072, dcm::VR_SQ,   "Time Slot Information Sequence"},
    { 0x0054, 0x0073, dcm::VR_DS,   "Time Slot Time"},
    { 0x0054, 0x0080, dcm::VR_US,   "Slice Vector"},
    { 0x0054, 0x0081, dcm::VR_US,   "Number of Slices"},
    { 0x0054, 0x0090, dcm::VR_US,   "Angular View Vector"},
    { 0x0054, 0x0100, dcm::VR_US,   "Time Slice Vector"},
    { 0x0054, 0x0101, dcm::VR_US,   "Number of Time Slices"},
    { 0x0054, 0x0200, dcm::VR_DS,   "Start Angle"},
    { 0x0054, 0x0202, dcm::VR_CS,   "Type of Detector Motion"},
    { 0x0054, 0x0210, dcm::VR_IS,   "Trigger Vector"},
    { 0x0054, 0x0211, dcm::VR_US,   "Number of Triggers in Phase"},
    { 0x0054, 0x0220, dcm::VR_SQ,   "View Code Sequence"},
    { 0x0054, 0x0222, dcm::VR_SQ,   "View Modifier Code Sequence"},
    { 0x0054, 0x0300, dcm::VR_SQ,   "Radionuclide Code Sequence"},
    { 0x0054, 0x0302, dcm::VR_SQ,   "Administration Route Code Sequence"},
    { 0x0054, 0x0304, dcm::VR_SQ,   "Radiopharmaceutical Code Sequence"},
    { 0x0054, 0x0306, dcm::VR_SQ,   "Calibration Data Sequence"},
    { 0x0054, 0x0308, dcm::VR_US,   "Energy Window Number"},
    { 0x0054, 0x0400, dcm::VR_SH,   "Image ID"},
    { 0x0054, 0x0410, dcm::VR_SQ,   "Patient Orientation Code Sequence"},
    { 0x0054, 0x0412, dcm::VR_SQ,   "Patient Orientation Modifier Code Sequence"},
    { 0x0054, 0x0414, dcm::VR_SQ,   "Patient Gantry Relationship Code Sequence"},
    { 0x0054, 0x1000, dcm::VR_CS,   "Series Type"},
    { 0x0054, 0x1001, dcm::VR_CS,   "Units"},
    { 0x0054, 0x1002, dcm::VR_CS,   "Counts Source"},
    { 0x0054, 0x1004, dcm::VR_CS,   "Reprojection Method"},
    { 0x0054, 0x1100, dcm::VR_CS,   "Randoms Correction Method"},
    { 0x0054, 0x1101, dcm::VR_LO,   "Attenuation Correction Method"},
    { 0x0054, 0x1102, dcm::VR_CS,   "Decay Correction"},
    { 0x0054, 0x1103, dcm::VR_LO,   "Reconstruction Method"},
    { 0x0054, 0x1104, dcm::VR_LO,   "Detector Lines of Response Used"},
    { 0x0054, 0x1105, dcm::VR_LO,   "Scatter Correction Method"},
    { 0x0054, 0x1200, dcm::VR_DS,   "Axial Acceptance"},
    { 0x0054, 0x1201, dcm::VR_IS,   "Axial Mash"},
    { 0x0054, 0x1202, dcm::VR_IS,   "Transverse Mash"},
    { 0x0054, 0x1203, dcm::VR_DS,   "Detector Element Size"},
    { 0x0054, 0x1210, dcm::VR_DS,   "Coincidence Window Width"},
    { 0x0054, 0x1220, dcm::VR_CS,   "Secondary Counts Type"},
    { 0x0054, 0x1300, dcm::VR_DS,   "Frame Reference Time"},
    { 0x0054, 0x1310, dcm::VR_IS,   "Primary (Prompts) Counts Accumulated"},
    { 0x0054, 0x1311, dcm::VR_IS,   "Secondary Counts Accumulated"},
    { 0x0054, 0x1320, dcm::VR_DS,   "Slice Sensitivity Factor"},
    { 0x0054, 0x1321, dcm::VR_DS,   "Decay Factor"},
    { 0x0054, 0x1322, dcm::VR_DS,   "Dose Calibration Factor"},
    { 0x0054, 0x1323, dcm::VR_DS,   "Scatter Fraction Factor"},
    { 0x0054, 0x1324, dcm::VR_DS,   "Dead Time Factor"},
    { 0x0054, 0x1330, dcm::VR_US,   "Image Index"},
    { 0x0054, 0x1400, dcm::VR_CS,   "Counts Included"},
    { 0x0054, 0x1401, dcm::VR_CS,   "Dead Time Correction Flag"},
};

const int TAG_TABLE_0054_SIZE = sizeof( TAG_TABLE_0054 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0060[] =
{
    { 0x0060, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0060, 0x3000, dcm::VR_SQ,   "Histogram Sequence"},
    { 0x0060, 0x3002, dcm::VR_US,   "Histogram Number of Bins"},
    { 0x0060, 0x3004, dcm::VR_US,   "Histogram First Bin Value"},
    { 0x0060, 0x3006, dcm::VR_US,   "Histogram Last Bin Value"},
    { 0x0060, 0x3008, dcm::VR_US,   "Histogram Bin Width"},
    { 0x0060, 0x3010, dcm::VR_LO,   "Histogram Explanation"},
    { 0x0060, 0x3020, dcm::VR_UL,   "Histogram Data"},
};

const int TAG_TABLE_0060_SIZE = sizeof( TAG_TABLE_0060 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0070[] =
{
    { 0x0070, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0070, 0x0001, dcm::VR_SQ,   "Graphic Annotation Sequence"},
    { 0x0070, 0x0002, dcm::VR_CS,   "Graphic Layer"},
    { 0x0070, 0x0003, dcm::VR_CS,   "Bounding Box Annotation Units"},
    { 0x0070, 0x0004, dcm::VR_CS,   "Anchor Point Annotation Units"},
    { 0x0070, 0x0005, dcm::VR_CS,   "Graphic Annotation Units"},
    { 0x0070, 0x0006, dcm::VR_ST,   "Unformatted Text Value"},
    { 0x0070, 0x0008, dcm::VR_SQ,   "Text Object Sequence"},
    { 0x0070, 0x0009, dcm::VR_SQ,   "Graphic Object Sequence"},
    { 0x0070, 0x0010, dcm::VR_FL,   "Bounding Box Top Left Hand Corner"},
    { 0x0070, 0x0011, dcm::VR_FL,   "Bounding Box Bottom Right Hand Corner"},
    { 0x0070, 0x0012, dcm::VR_CS,   "Bounding Box Text Horizontal Justification"},
    { 0x0070, 0x0014, dcm::VR_FL,   "Anchor Point"},
    { 0x0070, 0x0015, dcm::VR_CS,   "Anchor Point Visibility"},
    { 0x0070, 0x0020, dcm::VR_US,   "Graphic Dimensions"},
    { 0x0070, 0x0021, dcm::VR_US,   "Number of Graphic Points"},
    { 0x0070, 0x0022, dcm::VR_FL,   "Graphic Data"},
    { 0x0070, 0x0023, dcm::VR_CS,   "Graphic Type"},
    { 0x0070, 0x0024, dcm::VR_CS,   "Graphic Filled"},
    { 0x0070, 0x0041, dcm::VR_CS,   "Image Horizontal Flip"},
    { 0x0070, 0x0042, dcm::VR_US,   "Image Rotation"},
    { 0x0070, 0x0052, dcm::VR_SL,   "Displayed Area Top Left Hand Corner"},
    { 0x0070, 0x0053, dcm::VR_SL,   "Displayed Area Bottom Right Hand Corner"},
    { 0x0070, 0x005A, dcm::VR_SQ,   "Displayed Area Selection Sequence"},
    { 0x0070, 0x0060, dcm::VR_SQ,   "Graphic Layer Sequence"},
    { 0x0070, 0x0062, dcm::VR_IS,   "Graphic Layer Order"},
    { 0x0070, 0x0066, dcm::VR_US,   "Graphic Layer Recommended Display Grayscale Value"},
    { 0x0070, 0x0067, dcm::VR_US,   "Graphic Layer Recommended Display RGB Value"},
    { 0x0070, 0x0068, dcm::VR_LO,   "Graphic Layer Description"},
    { 0x0070, 0x0080, dcm::VR_CS,   "Presentation Label"},
    { 0x0070, 0x0081, dcm::VR_LO,   "Presentation Description"},
    { 0x0070, 0x0082, dcm::VR_DA,   "Presentation Creation Date"},
    { 0x0070, 0x0083, dcm::VR_TM,   "Presentation Creation Time"},
    { 0x0070, 0x0084, dcm::VR_PN,   "Presentation Creator's Name"},
    { 0x0070, 0x0100, dcm::VR_CS,   "Presentation Size Mode"},
    { 0x0070, 0x0101, dcm::VR_DS,   "Presentation Pixel Spacing"},
    { 0x0070, 0x0102, dcm::VR_IS,   "Presentation Pixel Aspect Ratio"},
    { 0x0070, 0x0103, dcm::VR_FL,   "Presentation Pixel Magnification Ratio"},
};

const int TAG_TABLE_0070_SIZE = sizeof( TAG_TABLE_0070 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0088[] =
{
    { 0x0088, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0088, 0x0130, dcm::VR_SH,   "Storage Media File-set ID"},
    { 0x0088, 0x0140, dcm::VR_UI,   "Storage Media File-set UID"},
    { 0x0088, 0x0200, dcm::VR_SQ,   "Icon Image Sequence"},
    { 0x0088, 0x0904, dcm::VR_LO,   "Topic Title"},
    { 0x0088, 0x0906, dcm::VR_ST,   "Topic Subject"},
    { 0x0088, 0x0910, dcm::VR_LO,   "Topic Author"},
    { 0x0088, 0x0912, dcm::VR_LO,   "Topic Key Words"},
};

const int TAG_TABLE_0088_SIZE = sizeof( TAG_TABLE_0088 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0100[] =
{
    { 0x0100, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0100, 0x0410, dcm::VR_CS,   "SOP Instance Status"},
    { 0x0100, 0x0420, dcm::VR_DT,   "SOP Authorization Date and Time"},
    { 0x0100, 0x0424, dcm::VR_LT,   "SOP Authorization Comment"},
    { 0x0100, 0x0426, dcm::VR_LO,   "Authorization Equipment Certification Number"},
};

const int TAG_TABLE_0100_SIZE = sizeof( TAG_TABLE_0100 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0400[] =
{
    { 0x0400, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0400, 0x0005, dcm::VR_US,   "MAC ID Number"},
    { 0x0400, 0x0010, dcm::VR_UI,   "MAC Calculation Transfer Syntax UID"},
    { 0x0400, 0x0015, dcm::VR_CS,   "MAC Algorithm"},
    { 0x0400, 0x0020, dcm::VR_AT,   "Data Elements Signed"},
    { 0x0400, 0x0100, dcm::VR_UI,   "Digital Signature UID"},
    { 0x0400, 0x0105, dcm::VR_DT,   "Digital Signature DateTime"},
    { 0x0400, 0x0110, dcm::VR_CS,   "Certificate Type"},
    { 0x0400, 0x0115, dcm::VR_OB,   "Certificate of Signer"},
    { 0x0400, 0x0120, dcm::VR_OB,   "Signature"},
    { 0x0400, 0x0305, dcm::VR_CS,   "Certified Timestamp Type"},
    { 0x0400, 0x0310, dcm::VR_OB,   "Certified Timestamp"},
    { 0x0400, 0x0500, dcm::VR_SQ,   "Encrypted Attributes Sequence"},
    { 0x0400, 0x0510, dcm::VR_UI,   "Encrypted Content Transfer Syntax UID"},
    { 0x0400, 0x0520, dcm::VR_OB,   "Encrypted Content"},
    { 0x0400, 0x0550, dcm::VR_SQ,   "Modified Attributes Sequence"},
};

const int TAG_TABLE_0400_SIZE = sizeof( TAG_TABLE_0400 ) / sizeof( TagTable );


const TagTable TAG_TABLE_2000[] =
{
    { 0x2000, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x2000, 0x0010, dcm::VR_IS,   "Number of Copies"},
    { 0x2000, 0x001E, dcm::VR_SQ,   "Printer Configuration Sequence"},
    { 0x2000, 0x0020, dcm::VR_CS,   "Print Priority"},
    { 0x2000, 0x0030, dcm::VR_CS,   "Medium Type"},
    { 0x2000, 0x0040, dcm::VR_CS,   "Film Destination"},
    { 0x2000, 0x0050, dcm::VR_LO,   "Film Session Label"},
    { 0x2000, 0x0060, dcm::VR_IS,   "Memory Allocation"},
    { 0x2000, 0x0061, dcm::VR_IS,   "Maximum Memory Allocation"},
    { 0x2000, 0x0062, dcm::VR_CS,   "Color Image Printing Flag"},
    { 0x2000, 0x0063, dcm::VR_CS,   "Collation Flag"},
    { 0x2000, 0x0065, dcm::VR_CS,   "Annotation Flag"},
    { 0x2000, 0x0067, dcm::VR_CS,   "Image Overlay Flag"},
    { 0x2000, 0x0069, dcm::VR_CS,   "Presentation LUT Flag"},
    { 0x2000, 0x006A, dcm::VR_CS,   "Image Box Presentation LUT Flag"},
    { 0x2000, 0x00A0, dcm::VR_US,   "Memory Bit Depth"},
    { 0x2000, 0x00A1, dcm::VR_US,   "Printing Bit Depth"},
    { 0x2000, 0x00A2, dcm::VR_SQ,   "Media Installed Sequence"},
    { 0x2000, 0x00A4, dcm::VR_SQ,   "Other Media Available Sequence"},
    { 0x2000, 0x00A8, dcm::VR_SQ,   "Supported Image Display Formats Sequence"},
    { 0x2000, 0x0500, dcm::VR_SQ,   "Referenced Film Box Sequence"},
    { 0x2000, 0x0510, dcm::VR_SQ,   "Referenced Stored Print Sequence"},
};

const int TAG_TABLE_2000_SIZE = sizeof( TAG_TABLE_2000 ) / sizeof( TagTable );


const TagTable TAG_TABLE_2010[] =
{
    { 0x2010, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x2010, 0x0010, dcm::VR_ST,   "Image Display Format"},
    { 0x2010, 0x0030, dcm::VR_CS,   "Annotation Display Format ID"},
    { 0x2010, 0x0040, dcm::VR_CS,   "Film Orientation"},
    { 0x2010, 0x0050, dcm::VR_CS,   "Film Size ID"},
    { 0x2010, 0x0052, dcm::VR_CS,   "Printer Resolution ID"},
    { 0x2010, 0x0054, dcm::VR_CS,   "Default Printer Resolution ID"},
    { 0x2010, 0x0060, dcm::VR_CS,   "Magnification Type"},
    { 0x2010, 0x0080, dcm::VR_CS,   "Smoothing Type"},
    { 0x2010, 0x00A6, dcm::VR_CS,   "Default Magnification Type"},
    { 0x2010, 0x00A7, dcm::VR_CS,   "Other Magnification Types Available"},
    { 0x2010, 0x00A8, dcm::VR_CS,   "Default Smoothing Type"},
    { 0x2010, 0x00A9, dcm::VR_CS,   "Other Smoothing Types Available"},
    { 0x2010, 0x0100, dcm::VR_CS,   "Border Density"},
    { 0x2010, 0x0110, dcm::VR_CS,   "Empty Image Density"},
    { 0x2010, 0x0120, dcm::VR_US,   "Min Density"},
    { 0x2010, 0x0130, dcm::VR_US,   "Max Density"},
    { 0x2010, 0x0140, dcm::VR_CS,   "Trim"},
    { 0x2010, 0x0150, dcm::VR_ST,   "Configuration Information"},
    { 0x2010, 0x0152, dcm::VR_LT,   "Configuration Information Description"},
    { 0x2010, 0x0154, dcm::VR_IS,   "Maximum Collated Films"},
    { 0x2010, 0x015E, dcm::VR_US,   "Illumination"},
    { 0x2010, 0x0160, dcm::VR_US,   "Reflected Ambient Light"},
    { 0x2010, 0x0376, dcm::VR_DS,   "Printer Pixel Spacing"},
    { 0x2010, 0x0500, dcm::VR_SQ,   "Referenced Film Session Sequence"},
    { 0x2010, 0x0510, dcm::VR_SQ,   "Referenced Image Box Sequence"},
    { 0x2010, 0x0520, dcm::VR_SQ,   "Referenced Basic Annotation Box Sequence"},
};

const int TAG_TABLE_2010_SIZE = sizeof( TAG_TABLE_2010 ) / sizeof( TagTable );


const TagTable TAG_TABLE_2020[] =
{
    { 0x2020, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x2020, 0x0010, dcm::VR_US,   "Image Position"},
    { 0x2020, 0x0020, dcm::VR_CS,   "Polarity"},
    { 0x2020, 0x0030, dcm::VR_DS,   "Requested Image Size"},
    { 0x2020, 0x0040, dcm::VR_CS,   "Requested Decimate/Crop Behavior"},
    { 0x2020, 0x0050, dcm::VR_CS,   "Requested Resolution ID"},
    { 0x2020, 0x00A0, dcm::VR_CS,   "Requested Image Size Flag"},
    { 0x2020, 0x00A2, dcm::VR_CS,   "Decimate/Crop Result"},
    { 0x2020, 0x0110, dcm::VR_SQ,   "Basic Grayscale Image Sequence"},
    { 0x2020, 0x0111, dcm::VR_SQ,   "Basic Color Image Sequence"},
};

const int TAG_TABLE_2020_SIZE = sizeof( TAG_TABLE_2020 ) / sizeof( TagTable );


const TagTable TAG_TABLE_2030[] =
{
    { 0x2030, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x2030, 0x0010, dcm::VR_US,   "Annotation Position"},
    { 0x2030, 0x0020, dcm::VR_LO,   "Text String"},
};

const int TAG_TABLE_2030_SIZE = sizeof( TAG_TABLE_2030 ) / sizeof( TagTable );


const TagTable TAG_TABLE_2040[] =
{
    { 0x2040, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x2040, 0x0010, dcm::VR_SQ,   "Referenced Overlay Plane Sequence"},
    { 0x2040, 0x0011, dcm::VR_US,   "Referenced Overlay Plane Groups"},
    { 0x2040, 0x0020, dcm::VR_SQ,   "Overlay Pixel Data Sequence"},
    { 0x2040, 0x0060, dcm::VR_CS,   "Overlay Magnification Type"},
    { 0x2040, 0x0070, dcm::VR_CS,   "Overlay Smoothing Type"},
    { 0x2040, 0x0072, dcm::VR_CS,   "Overlay or Image Magnification"},
    { 0x2040, 0x0074, dcm::VR_US,   "Magnify to Number of Columns"},
    { 0x2040, 0x0080, dcm::VR_CS,   "Overlay Foreground Density"},
    { 0x2040, 0x0082, dcm::VR_CS,   "Overlay Background Density"},
};

const int TAG_TABLE_2040_SIZE = sizeof( TAG_TABLE_2040 ) / sizeof( TagTable );


const TagTable TAG_TABLE_2050[] =
{
    { 0x2050, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x2050, 0x0010, dcm::VR_SQ,   "Presentation LUT Sequence"},
    { 0x2050, 0x0020, dcm::VR_CS,   "Presentation LUT Shape"},
    { 0x2050, 0x0500, dcm::VR_SQ,   "Referenced Presentation LUT Sequence"},
};

const int TAG_TABLE_2050_SIZE = sizeof( TAG_TABLE_2050 ) / sizeof( TagTable );


const TagTable TAG_TABLE_2100[] =
{
    { 0x2100, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x2100, 0x0010, dcm::VR_SH,   "Print Job ID"},
    { 0x2100, 0x0020, dcm::VR_CS,   "Execution Status"},
    { 0x2100, 0x0030, dcm::VR_CS,   "Execution Status Info"},
    { 0x2100, 0x0040, dcm::VR_DA,   "Creation Date"},
    { 0x2100, 0x0050, dcm::VR_TM,   "Creation Time"},
    { 0x2100, 0x0070, dcm::VR_AE,   "Originator"},
    { 0x2100, 0x0140, dcm::VR_AE,   "Destination AE"},
    { 0x2100, 0x0160, dcm::VR_SH,   "Owner ID"},
    { 0x2100, 0x0170, dcm::VR_IS,   "Number of Films"},
    { 0x2100, 0x0500, dcm::VR_SQ,   "Referenced Print Job Sequence"},
};

const int TAG_TABLE_2100_SIZE = sizeof( TAG_TABLE_2100 ) / sizeof( TagTable );


const TagTable TAG_TABLE_2110[] =
{
    { 0x2110, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x2110, 0x0010, dcm::VR_CS,   "Printer Status"},
    { 0x2110, 0x0020, dcm::VR_CS,   "Printer Status Info"},
    { 0x2110, 0x0030, dcm::VR_LO,   "Printer Name"},
    { 0x2110, 0x0099, dcm::VR_SH,   "Print Queue ID"},
};

const int TAG_TABLE_2110_SIZE = sizeof( TAG_TABLE_2110 ) / sizeof( TagTable );


const TagTable TAG_TABLE_2120[] =
{
    { 0x2120, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x2120, 0x0010, dcm::VR_CS,   "Queue Status"},
    { 0x2120, 0x0050, dcm::VR_SQ,   "Print Job Description Sequence"},
    { 0x2120, 0x0070, dcm::VR_SQ,   "Referenced Print Job Sequence"},
};

const int TAG_TABLE_2120_SIZE = sizeof( TAG_TABLE_2120 ) / sizeof( TagTable );


const TagTable TAG_TABLE_2130[] =
{
    { 0x2130, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x2130, 0x0010, dcm::VR_SQ,   "Print Management Capabilities Sequence"},
    { 0x2130, 0x0015, dcm::VR_SQ,   "Printer Characteristics Sequence"},
    { 0x2130, 0x0030, dcm::VR_SQ,   "Film Box Content Sequence"},
    { 0x2130, 0x0040, dcm::VR_SQ,   "Image Box Content Sequence"},
    { 0x2130, 0x0050, dcm::VR_SQ,   "Annotation Content Sequence"},
    { 0x2130, 0x0060, dcm::VR_SQ,   "Image Overlay Box Content Sequence"},
    { 0x2130, 0x0080, dcm::VR_SQ,   "Presentation LUT Content Sequence"},
    { 0x2130, 0x00A0, dcm::VR_SQ,   "Proposed Study Sequence"},
    { 0x2130, 0x00C0, dcm::VR_SQ,   "Original Image Sequence"},
};

const int TAG_TABLE_2130_SIZE = sizeof( TAG_TABLE_2130 ) / sizeof( TagTable );


const TagTable TAG_TABLE_3002[] =
{
    { 0x3002, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x3002, 0x0002, dcm::VR_SH,   "RT Image Label"},
    { 0x3002, 0x0003, dcm::VR_LO,   "RT Image Name"},
    { 0x3002, 0x0004, dcm::VR_ST,   "RT Image Description"},
    { 0x3002, 0x000A, dcm::VR_CS,   "Reported Values Origin"},
    { 0x3002, 0x000C, dcm::VR_CS,   "RT Image Plane"},
    { 0x3002, 0x000D, dcm::VR_DS,   "X-Ray Image Receptor Translation"},
    { 0x3002, 0x000E, dcm::VR_DS,   "X-Ray Image Receptor Angle"},
    { 0x3002, 0x0010, dcm::VR_DS,   "RT Image Orientation"},
    { 0x3002, 0x0011, dcm::VR_DS,   "Image Plane Pixel Spacing"},
    { 0x3002, 0x0012, dcm::VR_DS,   "RT Image Position"},
    { 0x3002, 0x0020, dcm::VR_SH,   "Radiation Machine Name"},
    { 0x3002, 0x0022, dcm::VR_DS,   "Radiation Machine SAD"},
    { 0x3002, 0x0024, dcm::VR_DS,   "Radiation Machine SSD"},
    { 0x3002, 0x0026, dcm::VR_DS,   "RT Image SID"},
    { 0x3002, 0x0028, dcm::VR_DS,   "Source to Reference Object Distance"},
    { 0x3002, 0x0029, dcm::VR_IS,   "Fraction Number"},
    { 0x3002, 0x0030, dcm::VR_SQ,   "Exposure Sequence"},
    { 0x3002, 0x0032, dcm::VR_DS,   "Meterset Exposure"},
    { 0x3002, 0x0034, dcm::VR_DS,   "Diaphragm Position"},
};

const int TAG_TABLE_3002_SIZE = sizeof( TAG_TABLE_3002 ) / sizeof( TagTable );


const TagTable TAG_TABLE_3004[] =
{
    { 0x3004, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x3004, 0x0001, dcm::VR_CS,   "DVH Type"},
    { 0x3004, 0x0002, dcm::VR_CS,   "Dose Units"},
    { 0x3004, 0x0004, dcm::VR_CS,   "Dose Type"},
    { 0x3004, 0x0006, dcm::VR_LO,   "Dose Comment"},
    { 0x3004, 0x0008, dcm::VR_DS,   "Normalization Point"},
    { 0x3004, 0x000A, dcm::VR_CS,   "Dose Summation Type"},
    { 0x3004, 0x000C, dcm::VR_DS,   "Grid Frame Offset Vector"},
    { 0x3004, 0x000E, dcm::VR_DS,   "Dose Grid Scaling"},
    { 0x3004, 0x0010, dcm::VR_SQ,   "RT Dose ROI Sequence"},
    { 0x3004, 0x0012, dcm::VR_DS,   "Dose Value"},
    { 0x3004, 0x0040, dcm::VR_DS,   "DVH Normalization Point"},
    { 0x3004, 0x0042, dcm::VR_DS,   "DVH Normalization Dose Value"},
    { 0x3004, 0x0050, dcm::VR_SQ,   "DVH Sequence"},
    { 0x3004, 0x0052, dcm::VR_DS,   "DVH Dose Scaling"},
    { 0x3004, 0x0054, dcm::VR_CS,   "DVH Volume Units"},
    { 0x3004, 0x0056, dcm::VR_IS,   "DVH Number of Bins"},
    { 0x3004, 0x0058, dcm::VR_DS,   "DVH Data"},
    { 0x3004, 0x0060, dcm::VR_SQ,   "DVH Referenced ROI Sequence"},
    { 0x3004, 0x0062, dcm::VR_CS,   "DVH ROI Contribution Type"},
    { 0x3004, 0x0070, dcm::VR_DS,   "DVH Minimum Dose"},
    { 0x3004, 0x0072, dcm::VR_DS,   "DVH Maximum Dose"},
    { 0x3004, 0x0074, dcm::VR_DS,   "DVH Mean Dose"},
};

const int TAG_TABLE_3004_SIZE = sizeof( TAG_TABLE_3004 ) / sizeof( TagTable );


const TagTable TAG_TABLE_3006[] =
{
    { 0x3006, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x3006, 0x0002, dcm::VR_SH,   "Structure Set Label"},
    { 0x3006, 0x0004, dcm::VR_LO,   "Structure Set Name"},
    { 0x3006, 0x0006, dcm::VR_ST,   "Structure Set Description"},
    { 0x3006, 0x0008, dcm::VR_DA,   "Structure Set Date"},
    { 0x3006, 0x0009, dcm::VR_TM,   "Structure Set Time"},
    { 0x3006, 0x0010, dcm::VR_SQ,   "Referenced Frame of Reference Sequence"},
    { 0x3006, 0x0012, dcm::VR_SQ,   "RT Referenced Study Sequence"},
    { 0x3006, 0x0014, dcm::VR_SQ,   "RT Referenced Series Sequence"},
    { 0x3006, 0x0016, dcm::VR_SQ,   "Contour Image Sequence"},
    { 0x3006, 0x0020, dcm::VR_SQ,   "Structure Set ROI Sequence"},
    { 0x3006, 0x0022, dcm::VR_IS,   "ROI Number"},
    { 0x3006, 0x0024, dcm::VR_UI,   "Referenced Frame of Reference UID"},
    { 0x3006, 0x0026, dcm::VR_LO,   "ROI Name"},
    { 0x3006, 0x0028, dcm::VR_ST,   "ROI Description"},
    { 0x3006, 0x002A, dcm::VR_IS,   "ROI Display Color"},
    { 0x3006, 0x002C, dcm::VR_DS,   "ROI Volume"},
    { 0x3006, 0x0030, dcm::VR_SQ,   "RT Related ROI Sequence"},
    { 0x3006, 0x0033, dcm::VR_CS,   "RT ROI Relationship"},
    { 0x3006, 0x0036, dcm::VR_CS,   "ROI Generation Algorithm"},
    { 0x3006, 0x0038, dcm::VR_LO,   "ROI Generation Description"},
    { 0x3006, 0x0039, dcm::VR_SQ,   "ROI Contour Sequence"},
    { 0x3006, 0x0040, dcm::VR_SQ,   "Contour Sequence"},
    { 0x3006, 0x0042, dcm::VR_CS,   "Contour Geometric Type"},
    { 0x3006, 0x0044, dcm::VR_DS,   "Contour Slab Thickness"},
    { 0x3006, 0x0045, dcm::VR_DS,   "Contour Offset Vector"},
    { 0x3006, 0x0046, dcm::VR_IS,   "Number of Contour Points"},
    { 0x3006, 0x0048, dcm::VR_IS,   "Contour Number"},
    { 0x3006, 0x0049, dcm::VR_IS,   "Attached Contours"},
    { 0x3006, 0x0050, dcm::VR_DS,   "Contour Data"},
    { 0x3006, 0x0080, dcm::VR_SQ,   "RT ROI Observations Sequence"},
    { 0x3006, 0x0082, dcm::VR_IS,   "Observation Number"},
    { 0x3006, 0x0084, dcm::VR_IS,   "Referenced ROI Number"},
    { 0x3006, 0x0085, dcm::VR_SH,   "ROI Observation Label"},
    { 0x3006, 0x0086, dcm::VR_SQ,   "RT ROI Identification Code Sequence"},
    { 0x3006, 0x0088, dcm::VR_ST,   "ROI Observation Description"},
    { 0x3006, 0x00A0, dcm::VR_SQ,   "Related RT ROI Observations Sequence"},
    { 0x3006, 0x00A4, dcm::VR_CS,   "RT ROI Interpreted Type"},
    { 0x3006, 0x00A6, dcm::VR_PN,   "ROI Interpreter"},
    { 0x3006, 0x00B0, dcm::VR_SQ,   "ROI Physical Properties Sequence"},
    { 0x3006, 0x00B2, dcm::VR_CS,   "ROI Physical Property"},
    { 0x3006, 0x00B4, dcm::VR_DS,   "ROI Physical Property Value"},
    { 0x3006, 0x00C0, dcm::VR_SQ,   "Frame of Reference Relationship Sequence"},
    { 0x3006, 0x00C2, dcm::VR_UI,   "Related Frame of Reference UID"},
    { 0x3006, 0x00C4, dcm::VR_CS,   "Frame of Reference Transformation Type"},
    { 0x3006, 0x00C6, dcm::VR_DS,   "Frame of Reference Transformation Matrix"},
    { 0x3006, 0x00C8, dcm::VR_LO,   "Frame of Reference Transformation Comment"},
};

const int TAG_TABLE_3006_SIZE = sizeof( TAG_TABLE_3006 ) / sizeof( TagTable );


const TagTable TAG_TABLE_3008[] =
{
    { 0x3008, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x3008, 0x0010, dcm::VR_SQ,   "Measured Dose Reference Sequence"},
    { 0x3008, 0x0012, dcm::VR_ST,   "Measured Dose Description"},
    { 0x3008, 0x0014, dcm::VR_CS,   "Measured Dose Type"},
    { 0x3008, 0x0016, dcm::VR_DS,   "Measured Dose Value"},
    { 0x3008, 0x0020, dcm::VR_SQ,   "Treatment Session Beam Sequence"},
    { 0x3008, 0x0022, dcm::VR_IS,   "Current Fraction Number"},
    { 0x3008, 0x0024, dcm::VR_DA,   "Treatment Control Point Date"},
    { 0x3008, 0x0025, dcm::VR_TM,   "Treatment Control Point Time"},
    { 0x3008, 0x002A, dcm::VR_CS,   "Treatment Termination Status"},
    { 0x3008, 0x002B, dcm::VR_SH,   "Treatment Termination Code"},
    { 0x3008, 0x002C, dcm::VR_CS,   "Treatment Verification Status"},
    { 0x3008, 0x0030, dcm::VR_SQ,   "Referenced Treatment Record Sequence"},
    { 0x3008, 0x0032, dcm::VR_DS,   "Specified Primary Meterset"},
    { 0x3008, 0x0033, dcm::VR_DS,   "Specified Secondary Meterset"},
    { 0x3008, 0x0036, dcm::VR_DS,   "Delivered Primary Meterset"},
    { 0x3008, 0x0037, dcm::VR_DS,   "Delivered Secondary Meterset"},
    { 0x3008, 0x003A, dcm::VR_DS,   "Specified Treatment Time"},
    { 0x3008, 0x003B, dcm::VR_DS,   "Delivered Treatment Time"},
    { 0x3008, 0x0040, dcm::VR_SQ,   "Control Point Delivery Sequence"},
    { 0x3008, 0x0042, dcm::VR_DS,   "Specified Meterset"},
    { 0x3008, 0x0044, dcm::VR_DS,   "Delivered Meterset"},
    { 0x3008, 0x0048, dcm::VR_DS,   "Dose Rate Delivered"},
    { 0x3008, 0x0050, dcm::VR_SQ,   "Treatment Summary Calculated Dose Reference Sequence"},
    { 0x3008, 0x0052, dcm::VR_DS,   "Cumulative Dose to Dose Reference"},
    { 0x3008, 0x0054, dcm::VR_DA,   "First Treatment Date"},
    { 0x3008, 0x0056, dcm::VR_DA,   "Most Recent Treatment Date"},
    { 0x3008, 0x005A, dcm::VR_IS,   "Number of Fractions Delivered"},
    { 0x3008, 0x0060, dcm::VR_SQ,   "Override Sequence"},
    { 0x3008, 0x0062, dcm::VR_AT,   "Override Parameter Pointer"},
    { 0x3008, 0x0064, dcm::VR_IS,   "Measured Dose Reference Number"},
    { 0x3008, 0x0066, dcm::VR_ST,   "Override Reason"},
    { 0x3008, 0x0070, dcm::VR_SQ,   "Calculated Dose Reference Sequence"},
    { 0x3008, 0x0072, dcm::VR_IS,   "Calculated Dose Reference Number"},
    { 0x3008, 0x0074, dcm::VR_ST,   "Calculated Dose Reference Description"},
    { 0x3008, 0x0076, dcm::VR_DS,   "Calculated Dose Reference Dose Value"},
    { 0x3008, 0x0078, dcm::VR_DS,   "Start Meterset"},
    { 0x3008, 0x007A, dcm::VR_DS,   "End Meterset"},
    { 0x3008, 0x0080, dcm::VR_SQ,   "Referenced Measured Dose Reference Sequence"},
    { 0x3008, 0x0082, dcm::VR_IS,   "Referenced Measured Dose Reference Number"},
    { 0x3008, 0x0090, dcm::VR_SQ,   "Referenced Calculated Dose Reference Sequence"},
    { 0x3008, 0x0092, dcm::VR_IS,   "Referenced Calculated Dose Reference Number"},
    { 0x3008, 0x00A0, dcm::VR_SQ,   "Beam Limiting Device Leaf Pairs Sequence"},
    { 0x3008, 0x00B0, dcm::VR_SQ,   "Recorded Wedge Sequence"},
    { 0x3008, 0x00C0, dcm::VR_SQ,   "Recorded Compensator Sequence"},
    { 0x3008, 0x00D0, dcm::VR_SQ,   "Recorded Block Sequence"},
    { 0x3008, 0x00E0, dcm::VR_SQ,   "Treatment Summary Measured Dose Reference Sequence"},
    { 0x3008, 0x013C, dcm::VR_DS,   "Delivered Pulse Repetition Interval"},
    { 0x3008, 0x0140, dcm::VR_SQ,   "Recorded Source Applicator Sequence"},
    { 0x3008, 0x0142, dcm::VR_IS,   "Referenced Source Applicator Number"},
    { 0x3008, 0x0150, dcm::VR_SQ,   "Recorded Channel Shield Sequence"},
    { 0x3008, 0x0152, dcm::VR_IS,   "Referenced Channel Shield Number"},
    { 0x3008, 0x0160, dcm::VR_SQ,   "Brachy Control Point Delivered Sequence"},
    { 0x3008, 0x0162, dcm::VR_DA,   "Safe Position Exit Date"},
    { 0x3008, 0x0164, dcm::VR_TM,   "Safe Position Exit Time"},
    { 0x3008, 0x0166, dcm::VR_DA,   "Safe Position Return Date"},
    { 0x3008, 0x0168, dcm::VR_TM,   "Safe Position Return Time"},
    { 0x3008, 0x0200, dcm::VR_CS,   "Current Treatment Status"},
    { 0x3008, 0x0202, dcm::VR_ST,   "Treatment Status Comment"},
    { 0x3008, 0x0220, dcm::VR_SQ,   "Fraction Group Summary Sequence"},
    { 0x3008, 0x0223, dcm::VR_IS,   "Referenced Fraction Number"},
    { 0x3008, 0x0224, dcm::VR_CS,   "Fraction Group Type"},
    { 0x3008, 0x0230, dcm::VR_CS,   "Beam Stopper Position"},
    { 0x3008, 0x0240, dcm::VR_SQ,   "Fraction Status Summary Sequence"},
    { 0x3008, 0x0250, dcm::VR_DA,   "Treatment Date"},
    { 0x3008, 0x0251, dcm::VR_TM,   "Treatment Time"},
    { 0x3008, 0x0100, dcm::VR_SQ,   "Recorded Source Sequence"},
    { 0x3008, 0x0105, dcm::VR_LO,   "Source Serial Number"},
    { 0x3008, 0x0110, dcm::VR_SQ,   "Treatment Session Application Setup Sequence"},
    { 0x3008, 0x0116, dcm::VR_CS,   "Application Setup Check"},
    { 0x3008, 0x0120, dcm::VR_SQ,   "Recorded Brachy Accessory Device Sequence"},
    { 0x3008, 0x0122, dcm::VR_IS,   "Referenced Brachy Accessory Device Number"},
    { 0x3008, 0x0130, dcm::VR_SQ,   "Recorded Channel Sequence"},
    { 0x3008, 0x0132, dcm::VR_DS,   "Specified Channel Total Time"},
    { 0x3008, 0x0134, dcm::VR_DS,   "Delivered Channel Total Time"},
    { 0x3008, 0x0136, dcm::VR_IS,   "Specified Number of Pulses"},
    { 0x3008, 0x0138, dcm::VR_IS,   "Delivered Number of Pulses"},
    { 0x3008, 0x013A, dcm::VR_DS,   "Specified Pulse Repetition Interval"},
};

const int TAG_TABLE_3008_SIZE = sizeof( TAG_TABLE_3008 ) / sizeof( TagTable );


const TagTable TAG_TABLE_300A[] =
{
    { 0x300A, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x300A, 0x0002, dcm::VR_SH,   "RT Plan Label"},
    { 0x300A, 0x0003, dcm::VR_LO,   "RT Plan Name"},
    { 0x300A, 0x0004, dcm::VR_ST,   "RT Plan Description"},
    { 0x300A, 0x0006, dcm::VR_DA,   "RT Plan Date"},
    { 0x300A, 0x0007, dcm::VR_TM,   "RT Plan Time"},
    { 0x300A, 0x0009, dcm::VR_LO,   "Treatment Protocols"},
    { 0x300A, 0x000A, dcm::VR_CS,   "Treatment Intent"},
    { 0x300A, 0x000B, dcm::VR_LO,   "Treatment Sites"},
    { 0x300A, 0x000C, dcm::VR_CS,   "RT Plan Geometry"},
    { 0x300A, 0x000E, dcm::VR_ST,   "Prescription Description"},
    { 0x300A, 0x0010, dcm::VR_SQ,   "Dose Reference Sequence"},
    { 0x300A, 0x0012, dcm::VR_IS,   "Dose Reference Number"},
    { 0x300A, 0x0014, dcm::VR_CS,   "Dose Reference Structure Type"},
    { 0x300A, 0x0015, dcm::VR_CS,   "Nominal Beam Energy Unit"},
    { 0x300A, 0x0016, dcm::VR_LO,   "Dose Reference Description"},
    { 0x300A, 0x0018, dcm::VR_DS,   "Dose Reference Point Coordinates"},
    { 0x300A, 0x001A, dcm::VR_DS,   "Nominal Prior Dose"},
    { 0x300A, 0x0020, dcm::VR_CS,   "Dose Reference Type"},
    { 0x300A, 0x0021, dcm::VR_DS,   "Constraint Weight"},
    { 0x300A, 0x0022, dcm::VR_DS,   "Delivery Warning Dose"},
    { 0x300A, 0x0023, dcm::VR_DS,   "Delivery Maximum Dose"},
    { 0x300A, 0x0025, dcm::VR_DS,   "Target Minimum Dose"},
    { 0x300A, 0x0026, dcm::VR_DS,   "Target Prescription Dose"},
    { 0x300A, 0x0027, dcm::VR_DS,   "Target Maximum Dose"},
    { 0x300A, 0x0028, dcm::VR_DS,   "Target Underdose Volume Fraction"},
    { 0x300A, 0x002A, dcm::VR_DS,   "Organ at Risk Full-volume Dose"},
    { 0x300A, 0x002B, dcm::VR_DS,   "Organ at Risk Limit Dose"},
    { 0x300A, 0x002C, dcm::VR_DS,   "Organ at Risk Maximum Dose"},
    { 0x300A, 0x002D, dcm::VR_DS,   "Organ at Risk Overdose Volume Fraction"},
    { 0x300A, 0x0040, dcm::VR_SQ,   "Tolerance Table Sequence"},
    { 0x300A, 0x0042, dcm::VR_IS,   "Tolerance Table Number"},
    { 0x300A, 0x0043, dcm::VR_SH,   "Tolerance Table Label"},
    { 0x300A, 0x0044, dcm::VR_DS,   "Gantry Angle Tolerance"},
    { 0x300A, 0x0046, dcm::VR_DS,   "Beam Limiting Device Angle Tolerance"},
    { 0x300A, 0x0048, dcm::VR_SQ,   "Beam Limiting Device Tolerance Sequence"},
    { 0x300A, 0x004A, dcm::VR_DS,   "Beam Limiting Device Position Tolerance"},
    { 0x300A, 0x004C, dcm::VR_DS,   "Patient Support Angle Tolerance"},
    { 0x300A, 0x004E, dcm::VR_DS,   "Table Top Eccentric Angle Tolerance"},
    { 0x300A, 0x0051, dcm::VR_DS,   "Table Top Vertical Position Tolerance"},
    { 0x300A, 0x0052, dcm::VR_DS,   "Table Top Longitudinal Position Tolerance"},
    { 0x300A, 0x0053, dcm::VR_DS,   "Table Top Lateral Position Tolerance"},
    { 0x300A, 0x0055, dcm::VR_CS,   "RT Plan Relationship"},
    { 0x300A, 0x0070, dcm::VR_SQ,   "Fraction Group Sequence"},
    { 0x300A, 0x0071, dcm::VR_IS,   "Fraction Group Number"},
    { 0x300A, 0x0078, dcm::VR_IS,   "Number of Fractions Planned"},
    { 0x300A, 0x0079, dcm::VR_IS,   "Number of Fraction Pattern Digits Per Day"},
    { 0x300A, 0x007A, dcm::VR_IS,   "Repeat Fraction Cycle Length"},
    { 0x300A, 0x007B, dcm::VR_LT,   "Fraction Pattern"},
    { 0x300A, 0x0080, dcm::VR_IS,   "Number of Beams"},
    { 0x300A, 0x0082, dcm::VR_DS,   "Beam Dose Specification Point"},
    { 0x300A, 0x0084, dcm::VR_DS,   "Beam Dose"},
    { 0x300A, 0x0086, dcm::VR_DS,   "Beam Meterset"},
    { 0x300A, 0x00A0, dcm::VR_IS,   "Number of Brachy Application Setups"},
    { 0x300A, 0x00A2, dcm::VR_DS,   "Brachy Application Setup Dose Specification Point"},
    { 0x300A, 0x00A4, dcm::VR_DS,   "Brachy Application Setup Dose"},
    { 0x300A, 0x00B0, dcm::VR_SQ,   "Beam Sequence"},
    { 0x300A, 0x00B2, dcm::VR_SH,   "Treatment Machine Name"},
    { 0x300A, 0x00B3, dcm::VR_CS,   "Primary Dosimeter Unit"},
    { 0x300A, 0x00B4, dcm::VR_DS,   "Source-Axis Distance"},
    { 0x300A, 0x00B6, dcm::VR_SQ,   "Beam Limiting Device Sequence"},
    { 0x300A, 0x00B8, dcm::VR_CS,   "RT Beam Limiting Device Type"},
    { 0x300A, 0x00BA, dcm::VR_DS,   "Source to Beam Limiting Device Distance"},
    { 0x300A, 0x00BC, dcm::VR_IS,   "Number of Leaf/Jaw Pairs"},
    { 0x300A, 0x00BE, dcm::VR_DS,   "Leaf Position Boundaries"},
    { 0x300A, 0x00C0, dcm::VR_IS,   "Beam Number"},
    { 0x300A, 0x00C2, dcm::VR_LO,   "Beam Name"},
    { 0x300A, 0x00C3, dcm::VR_ST,   "Beam Description"},
    { 0x300A, 0x00C4, dcm::VR_CS,   "Beam Type"},
    { 0x300A, 0x00C6, dcm::VR_CS,   "Radiation Type"},
    { 0x300A, 0x00C7, dcm::VR_CS,   "High-Dose Technique Type"},
    { 0x300A, 0x00C8, dcm::VR_IS,   "Reference Image Number"},
    { 0x300A, 0x00CA, dcm::VR_SQ,   "Planned Verification Image Sequence"},
    { 0x300A, 0x00CC, dcm::VR_LO,   "Imaging Device-Specific Acquisition Parameters"},
    { 0x300A, 0x00CE, dcm::VR_CS,   "Treatment Delivery Type"},
    { 0x300A, 0x00D0, dcm::VR_IS,   "Number of Wedges"},
    { 0x300A, 0x00D1, dcm::VR_SQ,   "Wedge Sequence"},
    { 0x300A, 0x00D2, dcm::VR_IS,   "Wedge Number"},
    { 0x300A, 0x00D3, dcm::VR_CS,   "Wedge Type"},
    { 0x300A, 0x00D4, dcm::VR_SH,   "Wedge ID"},
    { 0x300A, 0x00D5, dcm::VR_IS,   "Wedge Angle"},
    { 0x300A, 0x00D6, dcm::VR_DS,   "Wedge Factor"},
    { 0x300A, 0x00D8, dcm::VR_DS,   "Wedge Orientation"},
    { 0x300A, 0x00DA, dcm::VR_DS,   "Source to Wedge Tray Distance"},
    { 0x300A, 0x00E0, dcm::VR_IS,   "Number of Compensators"},
    { 0x300A, 0x00E1, dcm::VR_SH,   "Material ID"},
    { 0x300A, 0x00E2, dcm::VR_DS,   "Total Compensator Tray Factor"},
    { 0x300A, 0x00E3, dcm::VR_SQ,   "Compensator Sequence"},
    { 0x300A, 0x00E4, dcm::VR_IS,   "Compensator Number"},
    { 0x300A, 0x00E5, dcm::VR_SH,   "Compensator ID"},
    { 0x300A, 0x00E6, dcm::VR_DS,   "Source to Compensator Tray Distance"},
    { 0x300A, 0x00E7, dcm::VR_IS,   "Compensator Rows"},
    { 0x300A, 0x00E8, dcm::VR_IS,   "Compensator Columns"},
    { 0x300A, 0x00E9, dcm::VR_DS,   "Compensator Pixel Spacing"},
    { 0x300A, 0x00EA, dcm::VR_DS,   "Compensator Position"},
    { 0x300A, 0x00EB, dcm::VR_DS,   "Compensator Transmission Data"},
    { 0x300A, 0x00EC, dcm::VR_DS,   "Compensator Thickness Data"},
    { 0x300A, 0x00ED, dcm::VR_IS,   "Number of Boli"},
    { 0x300A, 0x00EE, dcm::VR_CS,   "Compensator Type"},
    { 0x300A, 0x00F0, dcm::VR_IS,   "Number of Blocks"},
    { 0x300A, 0x00F2, dcm::VR_DS,   "Total Block Tray Factor"},
    { 0x300A, 0x00F4, dcm::VR_SQ,   "Block Sequence"},
    { 0x300A, 0x00F5, dcm::VR_SH,   "Block Tray ID"},
    { 0x300A, 0x00F6, dcm::VR_DS,   "Source to Block Tray Distance"},
    { 0x300A, 0x00F8, dcm::VR_CS,   "Block Type"},
    { 0x300A, 0x00FA, dcm::VR_CS,   "Block Divergence"},
    { 0x300A, 0x00FB, dcm::VR_CS,   "Block Mounting Position"},
    { 0x300A, 0x00FC, dcm::VR_IS,   "Block Number"},
    { 0x300A, 0x00FE, dcm::VR_LO,   "Block Name"},
    { 0x300A, 0x0100, dcm::VR_DS,   "Block Thickness"},
    { 0x300A, 0x0102, dcm::VR_DS,   "Block Transmission"},
    { 0x300A, 0x0104, dcm::VR_IS,   "Block Number of Points"},
    { 0x300A, 0x0106, dcm::VR_DS,   "Block Data"},
    { 0x300A, 0x0107, dcm::VR_SQ,   "Applicator Sequence"},
    { 0x300A, 0x0108, dcm::VR_SH,   "Applicator ID"},
    { 0x300A, 0x0109, dcm::VR_CS,   "Applicator Type"},
    { 0x300A, 0x010A, dcm::VR_LO,   "Applicator Description"},
    { 0x300A, 0x010C, dcm::VR_DS,   "Cumulative Dose Reference Coefficient"},
    { 0x300A, 0x010E, dcm::VR_DS,   "Final Cumulative Meterset Weight"},
    { 0x300A, 0x0110, dcm::VR_IS,   "Number of Control Points"},
    { 0x300A, 0x0111, dcm::VR_SQ,   "Control Point Sequence"},
    { 0x300A, 0x0112, dcm::VR_IS,   "Control Point Index"},
    { 0x300A, 0x0114, dcm::VR_DS,   "Nominal Beam Energy"},
    { 0x300A, 0x0115, dcm::VR_DS,   "Dose Rate Set"},
    { 0x300A, 0x0116, dcm::VR_SQ,   "Wedge Position Sequence"},
    { 0x300A, 0x0118, dcm::VR_CS,   "Wedge Position"},
    { 0x300A, 0x011A, dcm::VR_SQ,   "Beam Limiting Device Position Sequence"},
    { 0x300A, 0x011C, dcm::VR_DS,   "Leaf/Jaw Positions"},
    { 0x300A, 0x011E, dcm::VR_DS,   "Gantry Angle"},
    { 0x300A, 0x011F, dcm::VR_CS,   "Gantry Rotation Direction"},
    { 0x300A, 0x0120, dcm::VR_DS,   "Beam Limiting Device Angle"},
    { 0x300A, 0x0121, dcm::VR_CS,   "Beam Limiting Device Rotation Direction"},
    { 0x300A, 0x0122, dcm::VR_DS,   "Patient Support Angle"},
    { 0x300A, 0x0123, dcm::VR_CS,   "Patient Support Rotation Direction"},
    { 0x300A, 0x0124, dcm::VR_DS,   "Table Top Eccentric Axis Distance"},
    { 0x300A, 0x0125, dcm::VR_DS,   "Table Top Eccentric Angle"},
    { 0x300A, 0x0126, dcm::VR_CS,   "Table Top Eccentric Rotation Direction"},
    { 0x300A, 0x0128, dcm::VR_DS,   "Table Top Vertical Position"},
    { 0x300A, 0x0129, dcm::VR_DS,   "Table Top Longitudinal Position"},
    { 0x300A, 0x012A, dcm::VR_DS,   "Table Top Lateral Position"},
    { 0x300A, 0x012C, dcm::VR_DS,   "Isocenter Position"},
    { 0x300A, 0x012E, dcm::VR_DS,   "Surface Entry Point"},
    { 0x300A, 0x0130, dcm::VR_DS,   "Source to Surface Distance"},
    { 0x300A, 0x0134, dcm::VR_DS,   "Cumulative Meterset Weight"},
    { 0x300A, 0x0180, dcm::VR_SQ,   "Patient Setup Sequence"},
    { 0x300A, 0x0182, dcm::VR_IS,   "Patient Setup Number"},
    { 0x300A, 0x0184, dcm::VR_LO,   "Patient Additional Position"},
    { 0x300A, 0x0190, dcm::VR_SQ,   "Fixation Device Sequence"},
    { 0x300A, 0x0192, dcm::VR_CS,   "Fixation Device Type"},
    { 0x300A, 0x0194, dcm::VR_SH,   "Fixation Device Label"},
    { 0x300A, 0x0196, dcm::VR_ST,   "Fixation Device Description"},
    { 0x300A, 0x0198, dcm::VR_SH,   "Fixation Device Position"},
    { 0x300A, 0x01A0, dcm::VR_SQ,   "Shielding Device Sequence"},
    { 0x300A, 0x01A2, dcm::VR_CS,   "Shielding Device Type"},
    { 0x300A, 0x01A4, dcm::VR_SH,   "Shielding Device Label"},
    { 0x300A, 0x01A6, dcm::VR_ST,   "Shielding Device Description"},
    { 0x300A, 0x01A8, dcm::VR_SH,   "Shielding Device Position"},
    { 0x300A, 0x01B0, dcm::VR_CS,   "Setup Technique"},
    { 0x300A, 0x01B2, dcm::VR_ST,   "Setup Technique Description"},
    { 0x300A, 0x01B4, dcm::VR_SQ,   "Setup Device Sequence"},
    { 0x300A, 0x01B6, dcm::VR_CS,   "Setup Device Type"},
    { 0x300A, 0x01B8, dcm::VR_SH,   "Setup Device Label"},
    { 0x300A, 0x01BA, dcm::VR_ST,   "Setup Device Description"},
    { 0x300A, 0x01BC, dcm::VR_DS,   "Setup Device Parameter"},
    { 0x300A, 0x01D0, dcm::VR_ST,   "Setup Reference Description"},
    { 0x300A, 0x01D2, dcm::VR_DS,   "Table Top Vertical Setup Displacement"},
    { 0x300A, 0x01D4, dcm::VR_DS,   "Table Top Longitudinal Setup Displacement"},
    { 0x300A, 0x01D6, dcm::VR_DS,   "Table Top Lateral Setup Displacement"},
    { 0x300A, 0x0200, dcm::VR_CS,   "Brachy Treatment Technique"},
    { 0x300A, 0x0202, dcm::VR_CS,   "Brachy Treatment Type"},
    { 0x300A, 0x0206, dcm::VR_SQ,   "Treatment Machine Sequence"},
    { 0x300A, 0x0210, dcm::VR_SQ,   "Source Sequence"},
    { 0x300A, 0x0212, dcm::VR_IS,   "Source Number"},
    { 0x300A, 0x0214, dcm::VR_CS,   "Source Type"},
    { 0x300A, 0x0216, dcm::VR_LO,   "Source Manufacturer"},
    { 0x300A, 0x0218, dcm::VR_DS,   "Active Source Diameter"},
    { 0x300A, 0x021A, dcm::VR_DS,   "Active Source Length"},
    { 0x300A, 0x0222, dcm::VR_DS,   "Source Encapsulation Nominal Thickness"},
    { 0x300A, 0x0224, dcm::VR_DS,   "Source Encapsulation Nominal Transmission"},
    { 0x300A, 0x0226, dcm::VR_LO,   "Source Isotope Name"},
    { 0x300A, 0x0228, dcm::VR_DS,   "Source Isotope Half Life"},
    { 0x300A, 0x022A, dcm::VR_DS,   "Reference Air Kerma Rate"},
    { 0x300A, 0x022C, dcm::VR_DA,   "Air Kerma Rate Reference Date"},
    { 0x300A, 0x022E, dcm::VR_TM,   "Air Kerma Rate Reference Time"},
    { 0x300A, 0x0230, dcm::VR_SQ,   "Application Setup Sequence"},
    { 0x300A, 0x0232, dcm::VR_CS,   "Application Setup Type"},
    { 0x300A, 0x0234, dcm::VR_IS,   "Application Setup Number"},
    { 0x300A, 0x0236, dcm::VR_LO,   "Application Setup Name"},
    { 0x300A, 0x0238, dcm::VR_LO,   "Application Setup Manufacturer"},
    { 0x300A, 0x0240, dcm::VR_IS,   "Template Number"},
    { 0x300A, 0x0242, dcm::VR_SH,   "Template Type"},
    { 0x300A, 0x0244, dcm::VR_LO,   "Template Name"},
    { 0x300A, 0x0250, dcm::VR_DS,   "Total Reference Air Kerma"},
    { 0x300A, 0x0260, dcm::VR_SQ,   "Brachy Accessory Device Sequence"},
    { 0x300A, 0x0262, dcm::VR_IS,   "Brachy Accessory Device Number"},
    { 0x300A, 0x0263, dcm::VR_SH,   "Brachy Accessory Device ID"},
    { 0x300A, 0x0264, dcm::VR_CS,   "Brachy Accessory Device Type"},
    { 0x300A, 0x0266, dcm::VR_LO,   "Brachy Accessory Device Name"},
    { 0x300A, 0x026A, dcm::VR_DS,   "Brachy Accessory Device Nominal Thickness"},
    { 0x300A, 0x026C, dcm::VR_DS,   "Brachy Accessory Device Nominal Transmission"},
    { 0x300A, 0x0280, dcm::VR_SQ,   "Channel Sequence"},
    { 0x300A, 0x0282, dcm::VR_IS,   "Channel Number"},
    { 0x300A, 0x0284, dcm::VR_DS,   "Channel Length"},
    { 0x300A, 0x0286, dcm::VR_DS,   "Channel Total Time"},
    { 0x300A, 0x0288, dcm::VR_CS,   "Source Movement Type"},
    { 0x300A, 0x028A, dcm::VR_IS,   "Number of Pulses"},
    { 0x300A, 0x028C, dcm::VR_DS,   "Pulse Repetition Interval"},
    { 0x300A, 0x0290, dcm::VR_IS,   "Source Applicator Number"},
    { 0x300A, 0x0291, dcm::VR_SH,   "Source Applicator ID"},
    { 0x300A, 0x0292, dcm::VR_CS,   "Source Applicator Type"},
    { 0x300A, 0x0294, dcm::VR_LO,   "Source Applicator Name"},
    { 0x300A, 0x0296, dcm::VR_DS,   "Source Applicator Length"},
    { 0x300A, 0x0298, dcm::VR_LO,   "Source Applicator Manufacturer"},
    { 0x300A, 0x029C, dcm::VR_DS,   "Source Applicator Wall Nominal Thickness"},
    { 0x300A, 0x029E, dcm::VR_DS,   "Source Applicator Wall Nominal Transmission"},
    { 0x300A, 0x02A0, dcm::VR_DS,   "Source Applicator Step Size"},
    { 0x300A, 0x02A2, dcm::VR_IS,   "Transfer Tube Number"},
    { 0x300A, 0x02A4, dcm::VR_DS,   "Transfer Tube Length"},
    { 0x300A, 0x02B0, dcm::VR_SQ,   "Channel Shield Sequence"},
    { 0x300A, 0x02B2, dcm::VR_IS,   "Channel Shield Number"},
    { 0x300A, 0x02B3, dcm::VR_SH,   "Channel Shield ID"},
    { 0x300A, 0x02B4, dcm::VR_LO,   "Channel Shield Name"},
    { 0x300A, 0x02B8, dcm::VR_DS,   "Channel Shield Nominal Thickness"},
    { 0x300A, 0x02BA, dcm::VR_DS,   "Channel Shield Nominal Transmission"},
    { 0x300A, 0x02C8, dcm::VR_DS,   "Final Cumulative Time Weight"},
    { 0x300A, 0x02D0, dcm::VR_SQ,   "Brachy Control Point Sequence"},
    { 0x300A, 0x02D2, dcm::VR_DS,   "Control Point Relative Position"},
    { 0x300A, 0x02D4, dcm::VR_DS,   "Control Point 3D Position"},
    { 0x300A, 0x02D6, dcm::VR_DS,   "Cumulative Time Weight"},
    { 0x300A, 0x02E0, dcm::VR_CS,   "Compensator Divergence"},
    { 0x300A, 0x02E1, dcm::VR_CS,   "Compensator Mounting Position"},
    { 0x300A, 0x02E2, dcm::VR_DS,   "Source to Compensator Distance"},
};

const int TAG_TABLE_300A_SIZE = sizeof( TAG_TABLE_300A ) / sizeof( TagTable );


const TagTable TAG_TABLE_300C[] =
{
    { 0x300C, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x300C, 0x0002, dcm::VR_SQ,   "Referenced RT Plan Sequence"},
    { 0x300C, 0x0004, dcm::VR_SQ,   "Referenced Beam Sequence"},
    { 0x300C, 0x0006, dcm::VR_IS,   "Referenced Beam Number"},
    { 0x300C, 0x0007, dcm::VR_IS,   "Referenced Reference Image Number"},
    { 0x300C, 0x0008, dcm::VR_DS,   "Start Cumulative Meterset Weight"},
    { 0x300C, 0x0009, dcm::VR_DS,   "End Cumulative Meterset Weight"},
    { 0x300C, 0x000A, dcm::VR_SQ,   "Referenced Brachy Application Setup Sequence"},
    { 0x300C, 0x000C, dcm::VR_IS,   "Referenced Brachy Application Setup Number"},
    { 0x300C, 0x000E, dcm::VR_IS,   "Referenced Source Number"},
    { 0x300C, 0x0020, dcm::VR_SQ,   "Referenced Fraction Group Sequence"},
    { 0x300C, 0x0022, dcm::VR_IS,   "Referenced Fraction Group Number"},
    { 0x300C, 0x0040, dcm::VR_SQ,   "Referenced Verification Image Sequence"},
    { 0x300C, 0x0042, dcm::VR_SQ,   "Referenced Reference Image Sequence"},
    { 0x300C, 0x0050, dcm::VR_SQ,   "Referenced Dose Reference Sequence"},
    { 0x300C, 0x0051, dcm::VR_IS,   "Referenced Dose Reference Number"},
    { 0x300C, 0x0055, dcm::VR_SQ,   "Brachy Referenced Dose Reference Sequence"},
    { 0x300C, 0x0060, dcm::VR_SQ,   "Referenced Structure Set Sequence"},
    { 0x300C, 0x006A, dcm::VR_IS,   "Referenced Patient Setup Number"},
    { 0x300C, 0x0080, dcm::VR_SQ,   "Referenced Dose Sequence"},
    { 0x300C, 0x00A0, dcm::VR_IS,   "Referenced Tolerance Table Number"},
    { 0x300C, 0x00B0, dcm::VR_SQ,   "Referenced Bolus Sequence"},
    { 0x300C, 0x00C0, dcm::VR_IS,   "Referenced Wedge Number"},
    { 0x300C, 0x00D0, dcm::VR_IS,   "Referenced Compensator Number"},
    { 0x300C, 0x00E0, dcm::VR_IS,   "Referenced Block Number"},
    { 0x300C, 0x00F0, dcm::VR_IS,   "Referenced Control Point Index"},
};

const int TAG_TABLE_300C_SIZE = sizeof( TAG_TABLE_300C ) / sizeof( TagTable );


const TagTable TAG_TABLE_300E[] =
{
    { 0x300E, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x300E, 0x0002, dcm::VR_CS,   "Approval Status"},
    { 0x300E, 0x0004, dcm::VR_DA,   "Review Date"},
    { 0x300E, 0x0005, dcm::VR_TM,   "Review Time"},
    { 0x300E, 0x0008, dcm::VR_PN,   "Reviewer Name"},
};

const int TAG_TABLE_300E_SIZE = sizeof( TAG_TABLE_300E ) / sizeof( TagTable );


const TagTable TAG_TABLE_4000[] =
{
    { 0x4000, 0x0000, dcm::VR_UL,   "Group Length"},
};

const int TAG_TABLE_4000_SIZE = sizeof( TAG_TABLE_4000 ) / sizeof( TagTable );


const TagTable TAG_TABLE_4008[] =
{
    { 0x4008, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x4008, 0x0040, dcm::VR_SH,   "Results ID"},
    { 0x4008, 0x0042, dcm::VR_LO,   "Results ID Issuer"},
    { 0x4008, 0x0050, dcm::VR_SQ,   "Referenced Interpretation Sequence"},
    { 0x4008, 0x0100, dcm::VR_DA,   "Interpretation Recorded Date"},
    { 0x4008, 0x0101, dcm::VR_TM,   "Interpretation Recorded Time"},
    { 0x4008, 0x0102, dcm::VR_PN,   "Interpretation Recorder"},
    { 0x4008, 0x0103, dcm::VR_LO,   "Reference to Recorded Sound"},
    { 0x4008, 0x0108, dcm::VR_DA,   "Interpretation Transcription Date"},
    { 0x4008, 0x0109, dcm::VR_TM,   "Interpretation Transcription Time"},
    { 0x4008, 0x010A, dcm::VR_PN,   "Interpretation Transcriber"},
    { 0x4008, 0x010B, dcm::VR_ST,   "Interpretation Text"},
    { 0x4008, 0x010C, dcm::VR_PN,   "Interpretation Author"},
    { 0x4008, 0x0111, dcm::VR_SQ,   "Interpretation Approver Sequence"},
    { 0x4008, 0x0112, dcm::VR_DA,   "Interpretation Approval Date"},
    { 0x4008, 0x0113, dcm::VR_TM,   "Interpretation Approval Time"},
    { 0x4008, 0x0114, dcm::VR_PN,   "Physician Approving Interpretation"},
    { 0x4008, 0x0115, dcm::VR_LT,   "Interpretation Diagnosis Description"},
    { 0x4008, 0x0117, dcm::VR_SQ,   "Interpretation Diagnosis Code Sequence"},
    { 0x4008, 0x0118, dcm::VR_SQ,   "Results Distribution List Sequence"},
    { 0x4008, 0x0119, dcm::VR_PN,   "Distribution Name"},
    { 0x4008, 0x011A, dcm::VR_LO,   "Distribution Address"},
    { 0x4008, 0x0200, dcm::VR_SH,   "Interpretation ID"},
    { 0x4008, 0x0202, dcm::VR_LO,   "Interpretation ID Issuer"},
    { 0x4008, 0x0210, dcm::VR_CS,   "Interpretation Type ID"},
    { 0x4008, 0x0212, dcm::VR_CS,   "Interpretation Status ID"},
    { 0x4008, 0x0300, dcm::VR_ST,   "Impressions"},
    { 0x4008, 0x4000, dcm::VR_ST,   "Results Comments"},
};

const int TAG_TABLE_4008_SIZE = sizeof( TAG_TABLE_4008 ) / sizeof( TagTable );


const TagTable TAG_TABLE_4FFE[] =
{
    { 0x4FFE, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x4FFE, 0x0001, dcm::VR_SQ,   "MAC Parameters Sequence"},
};

const int TAG_TABLE_4FFE_SIZE = sizeof( TAG_TABLE_4FFE ) / sizeof( TagTable );


const TagTable TAG_TABLE_5200[] =
{
    { 0x5200, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x5200, 0x9229, dcm::VR_SQ,   "Shared Functional Groups Sequence"},
    { 0x5200, 0x9230, dcm::VR_SQ,   "Per-frame Functional Groups Sequence"},
};

const int TAG_TABLE_5200_SIZE = sizeof( TAG_TABLE_5200 ) / sizeof( TagTable );


const TagTable TAG_TABLE_5400[] =
{
    { 0x5400, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x5400, 0x0100, dcm::VR_SQ,   "Waveform Sequence"},
    { 0x5400, 0x0110, dcm::VR_OB,   "Channel Minimum Value"},
    { 0x5400, 0x0112, dcm::VR_OB,   "Channel Maximum Value"},
    { 0x5400, 0x1004, dcm::VR_US,   "Waveform Bits Allocated"},
    { 0x5400, 0x1006, dcm::VR_CS,   "Waveform Sample Interpretation"},
    { 0x5400, 0x100A, dcm::VR_OB,   "Waveform Padding Value"},
    { 0x5400, 0x1010, dcm::VR_OB,   "Waveform Data"},
};

const int TAG_TABLE_5400_SIZE = sizeof( TAG_TABLE_5400 ) / sizeof( TagTable );


const TagTable TAG_TABLE_7FE0[] =
{
    { 0x7FE0, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x7FE0, 0x0010, dcm::VR_OB,   "Pixel Data"},
};

const int TAG_TABLE_7FE0_SIZE = sizeof( TAG_TABLE_7FE0 ) / sizeof( TagTable );


const TagTable TAG_TABLE_FFFA[] =
{
    { 0xFFFA, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0xFFFA, 0xFFFA, dcm::VR_SQ,   "Digital Signatures Sequence"},
};

const int TAG_TABLE_FFFA_SIZE = sizeof( TAG_TABLE_FFFA ) / sizeof( TagTable );


const TagTable TAG_TABLE_FFFC[] =
{
    { 0xFFFC, 0xFFFC, dcm::VR_OB,   "Data Set Trailing Padding"},
};

const int TAG_TABLE_FFFC_SIZE = sizeof( TAG_TABLE_FFFC ) / sizeof( TagTable );


const TagTable TAG_TABLE_FFFE[] =
{
    { 0xFFFE, 0xE000, dcm::VR_NONE, "Item Sequence Item"},
    { 0xFFFE, 0xE00D, dcm::VR_NONE, "Item Delimitation Item"},
    { 0xFFFE, 0xE0DD, dcm::VR_NONE, "Sequence Delimitation Item"},
};

const int TAG_TABLE_FFFE_SIZE = sizeof( TAG_TABLE_FFFE ) / sizeof( TagTable );


const TagTable TAG_TABLE_0002[] =
{
    { 0x0002, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0002, 0x0001, dcm::VR_OB,   "File Meta Information Version"},
    { 0x0002, 0x0002, dcm::VR_UI,   "Media Storage SOP Class UID"},
    { 0x0002, 0x0003, dcm::VR_UI,   "Media Storage SOP Instance UID"},
    { 0x0002, 0x0010, dcm::VR_UI,   "Transfer Syntax UID"},
    { 0x0002, 0x0012, dcm::VR_UI,   "Implementation Class UID"},
    { 0x0002, 0x0013, dcm::VR_SH,   "Implementation Version Name"},
    { 0x0002, 0x0016, dcm::VR_AE,   "Source Application Entity Title"},
    { 0x0002, 0x0100, dcm::VR_UI,   "Private Information Creator UID"},
    { 0x0002, 0x0102, dcm::VR_OB,   "Private Information"},
};

const int TAG_TABLE_0002_SIZE = sizeof( TAG_TABLE_0002 ) / sizeof( TagTable );


const TagTable TAG_TABLE_0004[] =
{
    { 0x0004, 0x0000, dcm::VR_UL,   "Group Length"},
    { 0x0004, 0x1130, dcm::VR_CS,   "File-set ID"},
    { 0x0004, 0x1141, dcm::VR_CS,   "File-set Descriptor File ID"},
    { 0x0004, 0x1142, dcm::VR_CS,   "Specific Character Set of File-set Descriptor File"},
    { 0x0004, 0x1200, dcm::VR_UL,   "Offset of the First Directory Record of the Root Directory Entity"},
    { 0x0004, 0x1202, dcm::VR_UL,   "Offset of the Last Directory Record of the Root Directory Entity"},
    { 0x0004, 0x1212, dcm::VR_US,   "File-set Consistency Flag"},
    { 0x0004, 0x1220, dcm::VR_SQ,   "Directory Record Sequence"},
    { 0x0004, 0x1400, dcm::VR_UL,   "Offset of the Next Directory Record"},
    { 0x0004, 0x1410, dcm::VR_US,   "Record In-use Flag"},
    { 0x0004, 0x1420, dcm::VR_UL,   "Offset of Referenced Lower-Level Directory Entity"},
    { 0x0004, 0x1430, dcm::VR_CS,   "Directory Record Type"},
    { 0x0004, 0x1432, dcm::VR_UI,   "Private Record UID"},
    { 0x0004, 0x1500, dcm::VR_CS,   "Referenced File ID"},
    { 0x0004, 0x1504, dcm::VR_UL,   "MRDR Directory Record Offset"},
    { 0x0004, 0x1510, dcm::VR_UI,   "Referenced SOP Class UID in File"},
    { 0x0004, 0x1511, dcm::VR_UI,   "Referenced SOP Instance UID in File"},
    { 0x0004, 0x1512, dcm::VR_UI,   "Referenced Transfer Syntax UID in File"},
    { 0x0004, 0x1600, dcm::VR_UL,   "Number of References"},
};

const int TAG_TABLE_0004_SIZE = sizeof( TAG_TABLE_0004 ) / sizeof( TagTable );

const int TAG_TABLE_SIZE = 
TAG_TABLE_0008_SIZE +
TAG_TABLE_0010_SIZE +
TAG_TABLE_0018_SIZE +
TAG_TABLE_0020_SIZE +
TAG_TABLE_0028_SIZE +
TAG_TABLE_0032_SIZE +
TAG_TABLE_0038_SIZE +
TAG_TABLE_003A_SIZE +
TAG_TABLE_0040_SIZE +
TAG_TABLE_0050_SIZE +
TAG_TABLE_0054_SIZE +
TAG_TABLE_0060_SIZE +
TAG_TABLE_0070_SIZE +
TAG_TABLE_0088_SIZE +
TAG_TABLE_0100_SIZE +
TAG_TABLE_0400_SIZE +
TAG_TABLE_2000_SIZE +
TAG_TABLE_2010_SIZE +
TAG_TABLE_2020_SIZE +
TAG_TABLE_2030_SIZE +
TAG_TABLE_2040_SIZE +
TAG_TABLE_2050_SIZE +
TAG_TABLE_2100_SIZE +
TAG_TABLE_2110_SIZE +
TAG_TABLE_2120_SIZE +
TAG_TABLE_2130_SIZE +
TAG_TABLE_3002_SIZE +
TAG_TABLE_3004_SIZE +
TAG_TABLE_3006_SIZE +
TAG_TABLE_3008_SIZE +
TAG_TABLE_300A_SIZE +
TAG_TABLE_300C_SIZE +
TAG_TABLE_300E_SIZE +
TAG_TABLE_4000_SIZE +
TAG_TABLE_4008_SIZE +
TAG_TABLE_4FFE_SIZE +
TAG_TABLE_5200_SIZE +
TAG_TABLE_5400_SIZE +
TAG_TABLE_7FE0_SIZE +
TAG_TABLE_FFFA_SIZE +
TAG_TABLE_FFFC_SIZE +
TAG_TABLE_FFFE_SIZE +
TAG_TABLE_0002_SIZE +
TAG_TABLE_0004_SIZE;

} // end of namespace dcm

} // end of namespace kvs

#endif // KVS__DCM__TAG_TABLE_H_INCLUDE
